		include	ipf.inc
Epson_FX_1050	segment	para	public
ESC	=	1bh
		assume	cs:Epson_FX_1050,ds:Epson_FX_1050
		IPF_HEADER	Init,Reset,Print,Buffer
;
		IPF_CONTROL	11h,Suppress_Immediately
		IPF_CONTROL	13h,Suppress_Immediately
		IPF_GROUP	ESC
		IPF_G_ENTRY	<"@">,Reset_Forced
		IPF_G_ENTRY	<"4">,Italics_On
		IPF_G_ENTRY	<"5">,Italics_Off
		IPF_G_ENTRY	<"=",">","#","6","7">,Suppress_Immediately
		IPF_G_ENTRY	<'s','U',19h,'N','3','A','J','l','Q','x','p','W','w','S','-','a','R','/','!',20h>,Pass_2
		IPF_G_ENTRY	<"k","t","%","I">,Suppress_2
		IPF_G_ENTRY	<"$","\","?">,Pass_3
		IPF_G_ENTRY	<"K","L","Y","Z">,Pass_Graphics
		IPF_G_ENTRY	<"*">,Pass_General_Graphics
		IPF_G_ENTRY	<"^">,Pass_9_Pin_Graphics
		IPF_G_ENTRY	<"C">,Pass_ESC_C
		IPF_G_ENTRY	<"B","D">,Pass_ESC_D_Or_B
		IPF_G_ENTRY	<"b">,Pass_ESC_b
		IPF_G_ENTRY	<":">,Suppress_4
		IPF_G_ENTRY	<"&">,Proceed_Font_Load
		IPF_END_TABLE
;
Buffer		db	(12)dup(?)	;	Save buffer
;
Italics		db	0
Page		db	CYR_PAGE
Reset_Sequence	db	ESC,"@"
Short_Reset_Seq	db	ESC,"6",ESC,"I",1
;
Set_ASCII	db	ESC,"%",0,ESC,"t",0
Set_GRAPH	db	ESC,"%",0,ESC,"t",1
Set_CYR		db	ESC,"%",1,ESC,"t",0
;
Count		dw	?
;
Reset		proc	far
		lea	si,Reset_Sequence
		mov	cx,7
		IPF_PRINT
		lea	si,Set_CYR
		mov	cx,6
		IPF_PRINT
		mov	Page,CYR_PAGE
		mov	Italics,0
		ret
		endp
;
Print		proc	far
		cmp	ah,Page
		je	T_001
		cmp	ah,ASCII_PAGE
		jne	T_002
		lea	si,Set_ASCII
		jmp	short T_004
T_002:		cmp	ah,CYR_PAGE
		jne	T_003
		lea	si,Set_CYR
		jmp	short T_004
T_003:		lea	si,Set_GRAPH
T_004:		mov	cx,6
		IPF_PRINT
		mov	Page,ah
T_001:		sub	al,dl
		ret
		endp
;
Reset_Forced	proc	far
		IPF_PRINT
		mov	bx,si
		lea	si,Short_Reset_Seq
		mov	cx,5
		IPF_PRINT
		mov	Page,CYR_PAGE
		mov	Italics,0
		xor	dx,dx
		ret
		endp
;
Suppress_Immediately	proc	far
		mov     bx,si
		xor	dx,dx
		ret
		endp
;
Italics_On	proc	far
		IPF_PRINT
		mov	bx,si
		mov	Italics,80h
		xor	dx,dx
		ret
		endp
;
Italics_Off	proc	far
		IPF_PRINT
		mov	bx,si
		mov	Italics,0
		xor	dx,dx
		ret
		endp
;
Pass_2		proc	far
		cmp	cx,3
T_011:		jb	T_010
		IPF_PRINT
		mov	bx,si
		xor	dx,dx
T_010:		ret
		endp
;
Pass_3		proc	far
		cmp	cx,4
		jmp	short T_011
		endp
;
Suppress_2	proc	far
		cmp	cx,3
T_013:		jb	T_012
		mov	bx,si
		xor	dx,dx
T_012:		ret
		endp
;
Suppress_4 	proc	far
		cmp	cx,5
		jmp	short T_013
		endp
;
Pass_Graphics	proc	far
		cmp	cx,4
T_021:		jb	T_020
		IPF_PRINT
		mov	ax,[bx-2]
		mov	Count,ax
		mov	bx,si
		lea	dx,Pass_By_Count
T_020:          ret
		endp
;
Pass_General_Graphics	proc	far
		cmp	cx,5
		jmp	short T_021
		endp
;
Pass_By_Count	proc	far
T_032:		IPF_PRINT
		dec	Count
		jnz	T_030
		xor	dx,dx
T_030:		mov	bx,si
		ret
		endp
;
Pass_By_Count_2	proc	far
		cmp	cx,2
		jb	T_031
		jmp	short T_032
		endp
;
Pass_9_Pin_Graphics	proc	far
		cmp	cx,5
		jb	T_031
		IPF_PRINT
		mov	ax,[bx-2]
		mov	Count,ax
		mov	bx,si
		lea	dx,Pass_By_Count_2
T_031:		ret
		endp
;
Pass_ESC_C	proc	far
		cmp	cx,3
		jb	T_040
		IPF_PRINT
		or	al,al
		jnz	T_041
T_043:		xor	dx,dx
		jmp	short T_042
T_041:		lea	dx,Short_Pass
T_042:		mov	bx,si
T_040:		ret
		endp
;
Short_Pass	proc	far
		IPF_PRINT
		jmp	short T_043
		endp
;
Pass_ESC_D_Or_B	proc 	far
		IPF_PRINT
		cmp	cx,1
		ja	T_050
		or	al,al
		jz	T_050
		xor	dx,dx
T_050:		mov	bx,si
T_051:		ret
		endp
;
Pass_ESC_b	proc	far
		cmp	cx,3
		jb	T_051
		lea	dx,Pass_ESC_D_Or_B
		jmp	short Pass_ESC_D_Or_B
		endp
;
Char_Codes	label	word
Cur_Char	db	?
Top_Char	db	?
;
Font_Load_Seq	db	ESC,"&",0
Code_To_Load	dw	?
;
Proceed_Font_Load	proc	far
		cmp	cx,5
		jb	T_060
		mov	ax,[bx-2]
		mov	Char_Codes,ax
		mov	bx,si
		lea	dx,Font_Load
T_060:		ret
		endp
;
Font_Load	proc	far
		cmp	cx,12
		jb	T_060
		mov	al,Cur_Char
		cmp	al,80h
		jb	No_Load
		cmp	al,0c0h
		jae	T_070
		sub	al,080h-'0'
		jmp	short Do_Load
T_070:		cmp	al,0e0h
		jb	No_Load
		sub	al,0e0h-'`'
Do_Load:	add	al,Italics
		mov	ah,al
		mov	Code_To_Load,ax
		push	si
		push	cx
		lea	si,Font_Load_Seq
		mov	cx,5
		IPF_PRINT
		pop	cx
		pop	si
		IPF_PRINT
No_Load:	mov	bx,si
		mov	al,Cur_Char
		cmp	al,Top_Char
		jb	T_071
		xor	dx,dx
		ret
T_071:		inc	Cur_Char
		ret
		endp
;
Init		proc	far
		lea	dx,Message
		mov	ah,09h
		int	21h
		mov	ax,IPF_VERSION
		ret
		endp
;
Message		db	"Epson FX-850/1050 IPF driver.",0ah,0dh
		db	"Release 1.01 Dec. 1991.  Max.B.Motovilov",0ah,0dh,0ah,0dh,"$"
;
	ends	Epson_FX_1050
	end
