		locals
		include	ipf.inc
Epson_LQ_1000	segment	para	public
ESC	=	1bh
		assume	cs:Epson_LQ_1000,ds:Epson_LQ_1000
		IPF_HEADER	Init,Reset,Print,Buffer
;
		IPF_CONTROL	11h,Suppress_Immediately
		IPF_CONTROL	13h,Suppress_Immediately
		IPF_GROUP	ESC
		IPF_G_ENTRY	<"@">,Reset_Forced
		IPF_G_ENTRY	<"4">,Italics_On
		IPF_G_ENTRY	<"5">,Italics_Off
		IPF_G_ENTRY	<"=",">","#","6","7">,Suppress_Immediately
		IPF_G_ENTRY	<'k','s','U',19h,'N','3','A','J','l','Q','x','p','W','w','S','-','a','R','/','!',20h>,Pass_2
		IPF_G_ENTRY	<"t","%","I">,Suppress_2
		IPF_G_ENTRY	<"e","f","$","\">,Pass_3
		IPF_G_ENTRY	<"?">,Set_Graphics
		IPF_G_ENTRY	<"K","L","Y","Z">,Pass_Graphics
		IPF_G_ENTRY	<"*">,Pass_General_Graphics
		IPF_G_ENTRY	<"C">,Pass_ESC_C
		IPF_G_ENTRY	<"B","D">,Pass_ESC_D_Or_B
		IPF_G_ENTRY	<"b">,Pass_ESC_b
		IPF_G_ENTRY	<":">,Suppress_4
		IPF_G_ENTRY	<"&">,Proceed_Font_Load
		IPF_END_TABLE
;
Buffer		db	(12)dup(?)	;	Save buffer
;
Italics		db	0
Page		db	CYR_PAGE
Reset_Sequence	db	ESC,"@"
;
Set_ASCII	db	ESC,"%",0,ESC,"t",0
Set_GRAPH	db	ESC,"%",0,ESC,"t",1
Set_CYR		db	ESC,"%",1,ESC,"t",0
;
Count		dw	?
;
Reset		proc	far
		lea	si,Reset_Sequence
		mov	cx,2
		IPF_PRINT
		lea	si,Set_ASCII
		mov	cx,6
		IPF_PRINT
		mov	Page,ASCII_PAGE
		mov	Italics,0
		ret
		endp
;
Print		proc	far
		cmp	ah,Page
		je	T_001
		cmp	ah,ASCII_PAGE
		jne	T_002
		lea	si,Set_ASCII
		jmp	short T_004
T_002:		cmp	ah,CYR_PAGE
		jne	T_003
		lea	si,Set_CYR
		jmp	short T_004
T_003:		lea	si,Set_GRAPH
T_004:		mov	cx,6
		IPF_PRINT
		mov	Page,ah
T_001:		sub	al,dl
		ret
		endp
;
Reset_Forced	proc	far
		IPF_PRINT
		mov	bx,si
		lea	si,Set_ASCII
		mov	cx,6
		IPF_PRINT
		mov	Page,ASCII_PAGE
		mov	Italics,0
		xor	dx,dx
		ret
		endp
;
Suppress_Immediately	proc	far
		mov     bx,si
		xor	dx,dx
		ret
		endp
;
Italics_On	proc	far
		IPF_PRINT
		mov	bx,si
		mov	Italics,80h
		xor	dx,dx
		ret
		endp
;
Italics_Off	proc	far
		IPF_PRINT
		mov	bx,si
		mov	Italics,0
		xor	dx,dx
		ret
		endp
;
Pass_2		proc	far
		cmp	cx,3
T_011:		jb	T_010
		IPF_PRINT
		mov	bx,si
		xor	dx,dx
T_010:		ret
		endp
;
Pass_3		proc	far
		cmp	cx,4
		jmp	short T_011
		endp
;
Suppress_2	proc	far
		cmp	cx,3
T_013:		jb	T_012
		mov	bx,si
		xor	dx,dx
T_012:		ret
		endp
;
Suppress_4 	proc	far
		cmp	cx,5
		jmp	short T_013
		endp
;
Graph_Modes	db	2,3,?,0,1	;	ESC (Y,Z,K,L)
;
Set_Graphics	proc	far
		cmp	cx,4
		jb	T_015
		IPF_PRINT
		mov	ax,[bx-2]
		and	al,7
		mov	bl,al
		xor	bh,bh
		mov	[bx+Graph_Modes],ah
		mov	bx,si
		xor	dx,dx
T_015:		ret
		endp
;
Pass_Graphics	proc	far
		cmp	cx,4
		jb	T_020
		push	bx
		mov	bl,[si+1]
		and	bl,7
		xor	bh,bh
		mov	al,[bx+Graph_Modes]
		pop	bx
T_021:;
		IPF_PRINT
		lea	dx,Pass_By_Count
		cmp	al,32
		jb	T_022
		lea	dx,Pass_By_Count_3
T_022:		mov	ax,[bx-2]
		mov	Count,ax
		mov	bx,si
T_020:          ret
		endp
;
Pass_General_Graphics	proc	far
		cmp	cx,5
		jb	T_020
		mov	al,[si+2]
		jmp	short T_021
		endp
;
Pass_By_Count	proc	far
T_032:		IPF_PRINT
		dec	Count
		jnz	T_030
		xor	dx,dx
T_030:		mov	bx,si
T_031:		ret
		endp
;
Pass_By_Count_3	proc	far
		cmp	cx,3
		jb	T_031
		jmp	short T_032
		endp
;
Pass_ESC_C	proc	far
		cmp	cx,3
		jb	T_040
		IPF_PRINT
		or	al,al
		jnz	T_041
T_043:		xor	dx,dx
		jmp	short T_042
T_041:		lea	dx,Short_Pass
T_042:		mov	bx,si
T_040:		ret
		endp
;
Short_Pass	proc	far
		IPF_PRINT
		jmp	short T_043
		endp
;
Pass_ESC_D_Or_B	proc 	far
		IPF_PRINT
		cmp	cx,1
		ja	T_050
		or	al,al
		jz	T_050
		xor	dx,dx
T_050:		mov	bx,si
T_051:		ret
		endp
;
Pass_ESC_b	proc	far
		cmp	cx,3
		jb	T_051
		lea	dx,Pass_ESC_D_Or_B
		jmp	short Pass_ESC_D_Or_B
		endp
;
Char_Codes	label	word
Cur_Char	db	?
Top_Char	db	?
;
Font_Bytes_Count	dw	?
;
Font_Load_Seq	db	ESC,"&"
Bank		db	0
Code_To_Load	dw	?
;
Load_Flag	db	?
;
Proceed_Font_Load	proc	far
		cmp	cx,5
		jb	T_060
		mov	al,[bx-3]
		mov	Bank,al
		mov	ax,[bx-2]
		mov	Char_Codes,ax
		mov	bx,si
		lea	dx,Font_Load
T_060:		ret
		endp
;
Font_Load	proc	far
		cmp	cx,3
		jb	T_060
		mov	Load_Flag,0
		mov	al,Cur_Char
		cmp	al,80h
		jae	@@1   			;	For compatibility
		add	al,80h                  ;       with LEF.COM
@@1:		cmp	al,0c0h
		jae	T_070
		sub	al,080h-'0'
		jmp	short Do_Load
T_070:		cmp	al,0e0h
		jb	No_Load
		sub	al,0e0h-'`'
Do_Load:	mov	Load_Flag,1
		add	al,Italics
		mov	ah,al
		mov	Code_To_Load,ax
		push	si
		push	cx
		lea	si,Font_Load_Seq
		mov	cx,5
		IPF_PRINT
		pop	cx
		pop	si
		IPF_PRINT
No_Load:	mov	al,[bx-2]
		mov	dl,3
		mul	dl
		mov	Font_Bytes_Count,ax
		lea	dx,LQ_Font_Pass
		mov	bx,si
		ret
End_Load:;
		mov	al,Cur_Char
		cmp	al,Top_Char
		jb	T_071
		xor	dx,dx
		ret
T_071:		inc	Cur_Char
T_075:		ret
		endp
;
LQ_Font_Pass	proc	far
		cmp	Load_Flag,0
		je	T_076
		IPF_PRINT
T_076:		mov	bx,si
		dec	Font_Bytes_Count
		jnz	T_075
		lea	dx,Font_Load
		jmp	short End_Load
		endp
;
Init		proc	far
		lea	dx,Message
		mov	ah,09h
		int	21h
		mov	ax,IPF_VERSION
		ret
		endp
;
Message		db	"Epson LQ-800/1000 IPF driver.",0ah,0dh
		db	"Release 1.01 Mar. 1992.  Max.B.Motovilov",0ah,0dh,0ah,0dh,"$"
;
	ends	Epson_LQ_1000
	end
