
#ifndef		__ARRAY__
#define		__ARRAY__

#include "user\def.h"
#include "user\types.hpp"

class Array;
class Link;
class _Link;

//  裡
// -------------
struct _Link {
  _Link *next, *prev;				  //  ᫥. <--> ।.
  virtual Type far type(void) { return Unknown; } //  
  virtual ~_Link() { }
};

// ᨢ
// ------
class Array {
  friend Link;
  _Link far *first, far *last, far *current;      // , ᫥, ⥪騩
  unsigned n, cnt;                                // 騩 , ⢮
  int no_killme;                                  // ਧ  㭨⮦
  void near pascal set(unsigned num);             //     ஬
  void far  pascal killme(_Link far *);           // 楤 㭨⮦
public:
  Array() { first = last = current = NULL; n = cnt = no_killme = 0; }
  ~Array();
  void insert(unsigned num, _Link far *p);        // ⠢ 
  void append(_Link far *p);                      //  
  void del(unsigned num);                         //  
  Link far *get(unsigned num);                    //  
  unsigned size(void) { return cnt; }             //  ࠧ
};

//    ⮢ ᨢ
// -----------------------------------
class Link: public _Link {
  friend Array;
  Array far *a;                                   // ᨢ   易 
public:
  ~Link() { if(a) { a->killme(this); a = NULL; } }//  㤠騩   ᨢ
} ;

#endif
