
class DATABASE {
  int handle;
  unsigned recsize;
  long lastrec;
  long recno;
  unsigned char *basedata;
public:
  DATABASE(char *name, unsigned recordsize);
  DATABASE(char *name, unsigned recordsize, void *data);
  ~DATABASE();
  void go( unsigned long pos );
  long skip( long cnt );
  void write( void );
  inline unsigned char &data();
  inline void commit( void );
  void append( void );
  void appendblank( void );
  int locate(void *cmpdata, int (*compare)(void *elem1, void *elem2));
};
