#include "user\def.h"

#define     VC_UNDEF         0   // । ⨯ 
#define     VC_MONO          1   // DA  / ஬ ᯫ
#define     VC_CGA           2   // CGA  / 梥⭮ ᯫ
#define     VC_CM1910        3   // CGA  / CM 1910
#define     VC_EGA_MONO      4   // EGA  / ஬ ᯫ
#define     VC_EGA           5   // EGA  / 梥⭮ ᯫ
#define     VC_PGA           6   // PGA  / 梥⭮ ᯫ
#define     VC_VGA_MONO      7   // VGA  / ஬  ᯫ
#define     VC_VGA           8   // VGA  / 梥⭮  ᯫ
#define     VC_MCGA_DIGIT    9   // MCGA / ஢ 梥⭮ ᯫ
#define     VC_MCGA_MONO     10  // MCGA / ஬  ᯫ
#define     VC_MCGA          11  // MCGA / 梥⭮  ᯫ


#define     VM_BW40          0  // CGA,EGA,VGA  ⮢    40x25    ୮-
#define     VM_CO40          1  // CGA,EGA,VGA  ⮢    40x25    ⭮
#define     VM_BW80          2  // CGA,EGA,VGA  ⮢    80x25    ୮-
#define     VM_CO80          3  // CGA,EGA,VGA  ⮢    80x25    ⭮
#define     VM_320x200x4     4  // CGA,EGA,VGA  ᪨  320x200  4 梥
#define     VM_640x200x2     6  // CGA,EGA,VGA  ᪨  640x200  2 梥
#define     VM_MONO          7  // MDA,EGA,VGA  ⮢    80x25    ஬
#define     VM_320x200x16    13 // EGA,VGA      ᪨  320x200  16 梥⮢
#define     VM_640x200x16    14 // EGA,VGA      ᪨  640x200  16 梥⮢
#define     VM_640x350x3     15 // EGA,VGA      ᪨  640x350  ୮-
#define     VM_640x350x16    16 // EGA,VGA      ᪨  640x350  16 梥⮢
#define     VM_640x480x2     17 // VGA          ᪨  640x480  ୮-
#define     VM_640x480x16    18 // VGA          ᪨  640x480  16 梥⮢
#define     VM_320x200x256   19 // VGA          ᪨  320x200  256 梥⮢

#define     _MONO         0       // Display constants
#define     _COLOR        1

#define     SHADOW_ON     1       //
#define     SHADOW_OFF    0

struct video_config {
  byte Mode      ; // Current mode
  byte VPage     ; // Current display page
  byte Rows      ; // Number of display rows - 1
  byte Cols      ; // Number of display columns
  byte VDisplay  ; // Either MONO or COLOR
  byte Adapter   ; // Adapter code
  word VSegment  ; // Video segment
  word VOffset   ; // Video page offset
  word CRT       ; //     CRT+6.
} ;

#define     SHADOW_OFF    0


#ifdef __cplusplus
extern "C" {
#endif

video_config far * far pascal getvconfig( void );
void               far pascal putxy( word x, word y, word mlen,
				     char far *str, byte color0, byte color1 );
void               far pascal replicate( word x, word y, char ch, word cnt,
                                         byte color );
// void               far pascal gotoxy( word x, word y );
void               far pascal getxy( word far *x, word far *y );
void               far pascal displaywindow( word x0, word y0, word x1,
                                             word y1, char far *boxstr,
                                             byte color, byte shadow );

void               far pascal savescreen( word x0, word y0, word x1,
                                          word y1, void far *buffer );

void               far pascal restscreen( void far *buffer );
word               far pascal buffersize( word x0, word y0, word x1, word y1 );

word               far pascal getcursor( void );
void               far pascal setcursor( word nCursor  );
void		   far pascal doscursor( void );
void               far pascal moveblock( word x0, word y0, word x1, word y1,
                                         word x, word y );
int                far pascal savefont( void far *Store, int nFirst, int nLast,
                                        int nBlock );
int                far pascal restfont( void far *Store, int nFirst, int nLast,
                                        int nBlock );
int                far pascal boldfont( int nBlock );
int                far pascal usualfont( int nBlock );
int                far pascal fontmax( void );
int                far pascal fontsize( void );
int                far pascal setblink( int nBlink );
int		   far pascal str2color( char far *Strore, char far *Color );
void               far pascal maxcolorlength( int newlength );
int                far pascal videomode( int newmode );
#ifdef  __cplusplus
}
#endif
