#include "user\def.h"

#ifndef __MYDOS__
#define __MYDOS__

#define	LSEEK_TOP	0
#define	LSEEK_SET	1
#define	LSEEK_BOTTOM	2

struct fat_info {
        word FAT_ID;
        word Clusters;
        word Sec_in_Clust;
        word Bytes_in_Sec;
};

struct DTA {
    char  reserved[21];
    byte  attribute;
    word  file_time;
    word  file_date;
    dword file_size;
    char  file_name[13];
};

#ifdef __cplusplus
int recurce_subdirs( char far *path, char far * far *_mask, int _maskcnt,
		    int (*_func)(DTA &, int) );
char far *ispath(void);
int deleteblk(word handle, dword offset, dword size);
int insertblk(word handle, dword offset, dword size, byte far *data);
extern "C" {
#endif

int   far pascal _fopenfile  ( char far *name, byte mode );
int   far pascal _fcreatfile ( char far *name, word attr );
word  far pascal _freadfile  ( int handle, void far *buffer, word size );
word  far pascal _fwritefile ( int handle, void far *buffer, word size );
int   far pascal closefile   ( int handle );
dword far pascal lseekfile   ( int handle, dword offs, byte from_where );
dword far pascal filesize    ( int handle );
int   far pascal geterror    ( void );
int   far pascal commit      ( int handle );
int   far pascal handlecnt   ( int newcnt );
int   far pascal get_fat_info( byte disk, struct fat_info far *f );
word  far pascal getattrib   ( char far *name );
int   far pascal setattrib   ( char far *name, word newattr );
int   far pascal getdir      ( char far *holddir, byte drive );
int   far pascal chdir       ( char far *newdir );
int   far pascal makedir     ( char far *newdir );
byte  far pascal getdisk     ( void );
int   far pascal setdisk     ( byte disk );
int   far pascal findfirst   ( char far *path, word attr, struct DTA far *dta );
int   far pascal findnext    ( struct DTA far *dta );
int   far pascal deletefile  ( char far *file );
void  far pascal dosout      ( char far *text );
void  far cdecl  listout     ( char far *, ... );
void  far pascal speaker     ( void far *sound, word len, int volume, int speed );
word  far *pascal  getaddr( void );
word  far pascal crc16( void far *str, word len, word oldcrc16 );
dword far pascal crc32( void far *str, word len, dword oldcrc32 );
#ifdef  __cplusplus
}
#endif

#endif
