#include "user\def.h"
#include "user\mouse.hpp"
#include "user\key.hpp"
#include "user\array.hpp"

#define		E_TIMER         0x0001
#define		E_KEY		0x0002
#define		E_KEY_FLAGS     0x0004
#define		E_MOUSE_KEY     0x0008
#define		E_MOUSE_MOVE    0x0010
#define		E_PRINTER_FREE  0x0020
#define		E_PRINTER_BIZY  0x0040
#define		E_COM1          0x0080
#define		E_COM2          0x0100

enum EventBreak { EBreak, EContinue };
class GetEvent;
typedef	void (far *UserFunc)(void);

class Event: public Link {
  friend word far waitevent(void);
  friend void far killevent(UserFunc func);
protected:
  UserFunc handler;
  word Mask;
public:
  Event(UserFunc h, word _Mask) { handler = h; Mask = _Mask; }
} ;

word setglobalmask( word newmask );
word setprocessmask( word newmask );
word far waitevent(void);
int far sethandler(UserFunc func, word mask);
void far killevent(UserFunc func);

extern word LastKey;
extern word KeyboardFlags;
extern MOUSE mouse;
