#include "def.h"

struct MOUSE {
int x,y;
char left_key:1;
char right_key:1;
char center_key:1;
} ;

#ifdef __cplusplus
 extern "C" {
#endif

int   far pascal chk_mouse(void);              /* check if mouse installed */
void  far pascal pointer_on(void);             /* display mouse pointer    */
void  far pascal pointer_off(void);            /* hide mouse pointer       */
void  far pascal speedxy(word x, word y);      /* set hor. and vert. speed */

/* speed must be 0,1,2,4,                                           */
void  far pascal int_rate(word speed);         /* set mouse hardware speed */
void  far pascal ask_mouse(struct MOUSE far *);       /* update MOUSE struct      */
void  far pascal setxy(word x,word y);         /* set mouse pointer to x,y */
void  far pascal sethor(word Left,word Right);
void  far pascal setver(word Top,word Bottom);
void  far pascal setspeed(word Xs,word Ys);

#ifdef __cplusplus
 }
#endif

