#include "user\def.h"

class MOUSE {
  char far *buffer;
  unsigned far getbuffersize(void);
  void     far savestate(void);
  void     far restorestate(void);
public:
  int x,y;
  int left_key;
  int right_key;
  int center_key;
  MOUSE(int left, int top, int right, int bottom);
  MOUSE( void );
  ~MOUSE();
  int   far check(void);                  /* check if mouse installed */
  void  far on(void);                     /* display mouse pointer    */
  void  far off(void);                    /* hide mouse pointer       */
  void  far speedxy(word x, word y);      /* set hor. and vert. speed */

  /* speed must be 0,1,2,4,                                           */
  void  far int_rate(word speed);         /* set mouse hardware speed */
  int   far ask(void);                    /* update MOUSE struct      */
  void  far setxy(word x,word y);         /* set mouse pointer to x,y */
  void  far sethor(word Left,word Right);
  void  far setver(word Top,word Bottom);
  void  far setspeed(word Xs, word Ys);
  void  far setshape(word pX, word pY, void far *mask);
  int   inbox(int left, int top, int right, int bottom)
    { return ( x >= left && x <= right && y >= top && y <= bottom ); }
} ;

