#define		K_NONE		0
#define		K_SHIFT		1
#define		K_CTRL		2
#define		K_ALT 		3

#define		PF_K_F1  	0
#define		PF_K_F2  	1
#define		PF_K_F3  	2
#define		PF_K_F4  	3
#define		PF_K_F5  	4
#define		PF_K_F6  	5
#define		PF_K_F7  	6
#define		PF_K_F8  	7
#define		PF_K_F9  	8
#define		PF_K_F10 	9

struct FKey {
  char far *label;
  void (far *handler)(void);
};

void far pascal pfinit( void );
void far pascal setlocalkey( int registr, int key, char far *label,
			     void (far *func)(void) );
void far pascal setglobalkey( int registr, int key, char far *label,
			      void (far *func)(void) );
FKey far *save_local_keys( void );
FKey far *save_global_keys( void );
void clear_local_keys( void );
void clear_global_keys( void );
void restore_local_keys( FKey far *local );
void restore_global_keys( FKey far *global );

class SaveKeys {
  FKey far *saved;
public:
  SaveKeys( int lClear = 0 );
  ~SaveKeys();
};


