#ifndef	  __WINDOW_DEFINED

#define   __WINDOW_DEFINED

#include "user\def.h"
#include "user\colors.h"
#include "user\disp.h"

#define	  WN_SHADOW		0x01
#define	  WN_WRAP		0x02
#define	  WN_NOSAVE		0x04
#define	  WN_CTITLE  		0x08
#define	  WN_5  		0x10
#define	  WN_6  		0x20
#define	  WN_7  		0x40
#define	  WN_8  		0x80

#define	  BTN_SELECT		0x01
#define	  BTN_PRESS 		0x02

void far pascal metabegin( void );
void far pascal metaend( void );
int far metainsert( int select );
void far metastatus( char far *text );
char far * far pascal color2bin( char far *color );
char far * far pascal color2bin( char far *storage, char far *color );

class WINDOW {
  char far *buffer;
  word x,y;
  byte colors[10];
  int  colortype;
  word cursor;
  char far *windowbox;
  char far *title;
  byte mode;
  word Wleft,Wtop,Wwidth,Wheight;
  int  deleted;
  void creat(void);
  friend void interrupt far new29( int ax, int bx, int cx, int dx,
				   int es, int ds, int si, int di, int bp );
public:
  word left,top,right,bottom,width,height;
  WINDOW far *prewindow;

  WINDOW();
  WINDOW(word x0,word y0,word _width,word _height,char far *box = pcBorder,
	 char far *_title = "", int colortype = coDialog, byte mode = 0);
  WINDOW(word wid, word heig, char far *box = pcBorder,
	 char far *_title = "", int colortype = coDialog, byte mode = 0);
  ~WINDOW();

  void say(word x, word y, char far *mess, int color0 = coMsg, int color1 = coItmLtr );
  void say(word x, word y, char far *mess, char far *color);
  void replicate(word x, word y, char symbol, int count, int color);
  void goxy(byte x, byte y);
  int  printxy(word x, word y, int color, char far *mess, ...);
  void scroll_vert(int cnt);
  void scroll_hor(int cnt);
  void setcursor( word nCursor ) { ::setcursor( cursor = nCursor ); }
  int  absx( int x ) { return left + x; }
  int  absy( int y ) { return top  + y; }
  void button( word x, word y, char far *label, int flag = 0 );
};

extern WINDOW far *metawindow;
extern int         Insert;               //  ० ⠢-
extern char far *pcDownArr;
extern char far *pcChoiceBox[];          //  ४⥫
extern char far *pcRadioBox[];           //  Radio ४⥫
extern char far *pcBox;                  //  ⠭⭮ ࠬ

#endif