/***********************************************************************
  : C:\GLASS\CPP\PATCHER\ERROR.CPP
  祭: ⥬ ࠡ⪨ 訡
  ᪮ ࠢ (C) 30/07/95 ਩ .⥪
***********************************************************************/

#include <stdio.h>
#include <stddef.h>
#include "error.hpp"

/***********************************************************************
   쥧 訡
***********************************************************************/

const char *errType[] = { "Warning", "Error", "Fatal" };

/***********************************************************************
   訡   ᠭ
***********************************************************************/

const char *errList[] = { "Illegal Dos version"       ,
                          "Out of memory"             ,
                          "Memory allocation error"   ,
                          "Invalid argument"          ,
                          "Invalid number of argument",
                          "Open error"                ,
                          "Read error"                ,
                          "Write error"               ,
                          "Acces error"               ,
                          "Invalid format"            };

/***********************************************************************
  稪 訡
***********************************************************************/

long _errcount = 0;
long _wrncount = 0;

/***********************************************************************
  
***********************************************************************/
error::error( const char *name = NULL )
{
  type    = ET_ERROR;
  code    = EC_NONE;
  message = NULL;
  object  = NULL;
  subcode = EC_NONE;
  subname = name;
}

/***********************************************************************
   訡
***********************************************************************/
void error::gen()
{
  printf( "%s: ", errType[type] );

  if( type == ET_WARNING ) ++_wrncount;
  if( type == ET_ERROR   ) ++_errcount;
  if( type == ET_FATAL   ) ++_errcount;

  if( subname != NULL )
    printf( "%s(%u) ", subname, subcode );

  if( code != EC_NONE )
    printf( "%s", errList[code] );
  else if( message != NULL )
    printf( "%s", message );

  if( object != NULL )
    printf( ": %s", object );

  printf( "\n" );
}

/***********************************************************************
    稪 訡
***********************************************************************/
long error::errcount() { return _errcount; }
long error::wrncount() { return _wrncount; }
