;
; ⮡ࠦ ଠ樨                                     
; ᪮ ࠢ (C) 1997 ਩ .⥪                        
;

; $Log: dispinfo.asm $
; Revision 1.1  2000/05/15 10:52:10  GLASS
; Initial revision
;

       include support.inc
       include control.inc
       include global.inc
       include constant.inc
       include dispinfo.inc
       include vesa.inc

.data
.286
;ͻ
; 饭 
;ͼ

msgTitle      DB  "VESA DDC Display Information. Version 1.01",CR,LF
              DB  "Copyright (C) 1997-2000 Dmitry A.Steklenev",CR,LF,CR,LF,0

msgProg       DB  "DISPINFO" ,0
msgDos        DB  "DOS"      ,0

msgPause      DB  "Press any key to continue..."            ,CR,0
msgPauseDel   DB  "                            "            ,CR,0
msgWaitInst   DB  "Check VBE/DDC support. Please wait..."   ,0
msgHome       DB  CR,0

errWindow     DB  "This program can't run in windowed mode" ,CR,LF,0
errNotSup     DB  "VBE/DDC specification is not supported"  ,CR,LF,0
errRead       DB  "Read EDID block failed"                  ,CR,LF,0

msgDDCLvl     DB  "DDC level supported: "                   ,0
msgManID      DB  "    Manufacturer ID: "                   ,0
msgSerial     DB  "      Serial number: "                   ,0
msgManDate    DB  "       Manufactured: "                   ,0
msgVoltage    DB  "      Voltage level: "                   ,0

msgResolut    DB  "resolution ",0
msgRefresh    DB  "supported refresh: ",0

res1280x1024  DB  "1280x1024 " ,0
res1024x768   DB  "1024x0768 " ,0
res832x624    DB  "0832x0624 " ,0
res800x600    DB  "0800x0600 " ,0
res640x480    DB  "0640x0480 " ,0
res720x400    DB  "0720x0400 " ,0

rfr75         DB  "75 " ,0
rfr72         DB  "72 " ,0
rfr70         DB  "70 " ,0
rfr67         DB  "67 " ,0
rfr60         DB  "60 " ,0
rfr56         DB  "56 " ,0
rfr80         DB  "80 " ,0
rfr88         DB  "88 " ,0
rfr87         DB  "87i ",0

strWeek       DB  " week ", 0

strDDC1       DB  "DDC 1"          ,0
strDDC2       DB  "DDC 2"          ,0
strDDC12      DB  "DDC 1 and DDC 2",0

ofsDDC        DW  strDDC1, strDDC2, strDDC12

str700V       DB  "0.700V/0.300V (1.00 Vp-p)",0
str714V       DB  "0.714V/0.286V"            ,0
str100V       DB  "0.100V/0.400V"            ,0
strUnknown    DB  "?"                        ,0

ofsVoltage    DW  str700V, str714V, str100V, strUnknown

strAnalog     DB  " (analog)"  ,0
strDigital    DB  " (digital)" ,0

;ͻ
;   
;ͼ

;-----------------------------------;
scrBottom DB  0                     ; ᫮ ப  ࠭
scrRow    DB  0                     ; ᫮ 뢥 ப
;-----------------------------------;
dspInfo   EDID <>                   ; ଠ樮 
dspResr   DB   128 dup (0)          ;  直 砩 (   VESA)
;-----------------------------------;
strInt    DB   '00000',0            ; 16-⮢ 筮 ᫮
strLng    DB   '0000000000',0       ; 32-⮢ 筮 ᫮
;-----------------------------------;

.code
.startup
;ͻ
;  楤                                                    
;ͼ
dispMain proc near

  call  _scrFrame             ;  ᫥ ப
  mov   scrBottom,dh          ; ࠭.

  @out  msgTitle              ;뢥 ᪨ ࠢ.
  mov   scrRow,3              ;( 3? ப  ᯫ).

  @int 4010h,2Fh              ;ணࠬ   ⮢
  @if  ax #= 4010h            ;  ० OS/2
       @outb 03D6h,82h
       in    al,dx
       @if   al == 0
             @err ,,,errWindow
       @endif
  @endif

  call  _dosReDirect?
  @if   al == FALSE
        @out  msgWaitInst
        call  Eject
        call  Eject
  @endif

  mov   bl,VDDC_INST          ;஢ প ஬ 
  xor   cx,cx                 ;஬ ᯥ䨪樨
  @int  VESA_DDC, 10h         ;VBE/DDC
  and   bx,3                  ;뤥 ন ஢ DDC

  @if   <ax #= 004Fh> or <bl == 0>
        @err ,,,errNotSup
  @endif

  dec   bx
  shl   bx,1
  @out  msgDDCLvl             ;뢥 ଠ  ন
  mov   si,ofsDDC[bx]         ;஢ DDC
  @out  si
  call  Eject

  xor   cx,cx                 ; ଠ 
  xor   dx,dx                 ;ᯫ.
  mvx   es,ds
  lea   di,dspInfo
  mov   bl,VDDC_EDID
  @int  VESA_DDC, 10h

  @if   ax #= 004Fh
        @err ,,,errRead
  @endif

  @ltr  macro  letter
        mov   bx,dspInfo.edidmid
        xchg  bh,bl
        getfield letter al, bx
        add   al,'@'
        call  _dosChar
  endm

  @chr  macro  char
        mov    al,char
        call   _dosChar
  endm

  @out  msgManID              ;뢥 䨪
  @ltr  letter1st             ;ந⥫.
  @ltr  letter2st
  @ltr  letter3st
  @chr  ' '

  @dcv  dspInfo.edididcode strInt 5
  @out  si                    ;뢥 䨪樮
  call  Eject                 ;.

  @out  msgSerial             ;뢥 ਩ .
  @dcv  dspInfo.edidserno strLng 10
  @out  si
  call  Eject

  @out  msgManDate            ;뢥  ந⢠
  xor   ax,ax                 ;
  mov   al,dspInfo.edidweek
  @dcv  ax strInt+2 3
  @out  si
  @out  strWeek
  xor   ax,ax
  mov   al,dspInfo.edidyear
  add   ax,1990
  @dcv  ax strInt+1 4
  @out  si
  call  Eject

  @out  msgVoltage            ;뢥 ஢  ⨯
  mov   al,dspInfo.edidvinp   ;室 ᨣ.
  getfield voltage bl, al
  xor   bh,bh
  shl   bx,1
  mov   si,ofsVoltage[bx]
  @out  si

  @if   dspInfo.edidvinp && <mask digital>
        @out strDigital
  @else
        @out strAnalog
  @endif

  call  Eject                 ;뢥 ন
  call  Eject                 ;०

  @if   dspInfo.edidestim && RFR128x124_75
        @out msgResolut
        @out res1280x1024
        @out msgRefresh
        @out rfr75
        call Eject
  @endif

  @if   dspInfo.edidestim && <RFR124x768_75+\
                              RFR124x768_70+\
                              RFR124x768_60+\
                              RFR124x768_87 >
        @out msgResolut
        @out res1024x768
        @out msgRefresh
        @if  dspInfo.edidestim && RFR124x768_75
             @out rfr75
        @endif
        @if  dspInfo.edidestim && RFR124x768_70
             @out rfr70
        @endif
        @if  dspInfo.edidestim && RFR124x768_60
             @out rfr60
        @endif
        @if  dspInfo.edidestim && RFR124x768_87
             @out rfr87
        @endif
        call Eject
  @endif

  @if   dspInfo.edidestim && RFR832x624_75
        @out msgResolut
        @out res832x624
        @out msgRefresh
        @out rfr75
        call Eject
  @endif

  @if   dspInfo.edidestim && <RFR800x600_75+\
                              RFR800x600_72+\
                              RFR800x600_60+\
                              RFR800x600_56 >
        @out msgResolut
        @out res800x600
        @out msgRefresh
        @if  dspInfo.edidestim && RFR800x600_75
             @out rfr75
        @endif
        @if  dspInfo.edidestim && RFR800x600_72
             @out rfr72
        @endif
        @if  dspInfo.edidestim && RFR800x600_60
             @out rfr60
        @endif
        @if  dspInfo.edidestim && RFR800x600_56
             @out rfr56
        @endif
        call Eject
  @endif

  @if   dspInfo.edidestim && <RFR640x480_75+\
                              RFR640x480_72+\
                              RFR640x480_67+\
                              RFR640x480_60 >
        @out msgResolut
        @out res640x480
        @out msgRefresh
        @if  dspInfo.edidestim && RFR640x480_75
             @out rfr75
        @endif
        @if  dspInfo.edidestim && RFR640x480_72
             @out rfr72
        @endif
        @if  dspInfo.edidestim && RFR640x480_67
             @out rfr67
        @endif
        @if  dspInfo.edidestim && RFR640x480_60
             @out rfr60
        @endif
        call Eject
  @endif

  @if   dspInfo.edidestim && <RFR720x400_88+\
                              RFR720x400_70 >
        @out msgResolut
        @out res720x400
        @out msgRefresh
        @if  dspInfo.edidestim && RFR720x400_88
             @out rfr88
        @endif
        @if  dspInfo.edidestim && RFR720x400_70
             @out rfr70
        @endif
        call Eject
  @endif

  @quit 0
endp

;ͻ
; ॢ ப                                                       
;ͼ
Eject proc near uses ax bx cx dx di si ds es

  call _dosEject  ;ॢ ப 
  inc  scrRow     ;㢥 稪 ப.

  mov  ah,scrRow
  @if  ah == scrBottom
       call _dosReDirect?
       @if  al == FALSE
            @out msgPause
            @int 0,16h
            @out msgPauseDel
            mov  scrRow,0
       @endif
  @endif

  ret
endp

end @Startup
