#ifndef __DEF__

#define __DEF__

#ifdef __cplusplus
#define c_type   extern "C"
#else
#define c_type
#endif

#ifdef  __SHORT__
  c_type void _setupio( void ) {}
#endif

typedef unsigned char   byte;
typedef unsigned int    word;
typedef unsigned long  dword;

#define	_FCMP	(int (*)(const void*,const void*))

/*  ।騥 ᫮ ।  (char) 㭪樨 ਭ饩
   ६ ᫮ ࠬ஢: PARBYTES(lpar) ==> bytes,  lpar
   () ࠬ 㭪樨. */

#define _PARTYPE(lpar)  ( *( (unsigned char far*)( (void **)*( ((void **)&(lpar)) - 1) ) ))
#define	_PARBYTE(lpar)	( (int)*( (char far*)( (void **)*( ((void **)&(lpar)) - 1) ) + 2 ))
#define	_PARWORD(lpar)	( (int)*( (int far*)( (void **)*( ((void **)&(lpar)) - 1) ) + 1 ))
#define	PARBYTES(lpar)	( (_PARTYPE(lpar) == 0x83)? _PARBYTE(lpar) : _PARWORD(lpar) )

/* ଠ 㪠⥫ far: NORMPTR( void far *ptr ) ==> void far *norm_ptr
   ᫥ ଠ樨 㪠⥫ ࠧ묥뢠 ( ⨯ void far *) */

#define _SEG(ptr)       ( (unsigned)(void _seg *)(void far *)(ptr))
#define _OFF(ptr)       ( (unsigned)(ptr))
#define NORMPTR(ptr)    ( (void _seg *)( _SEG(ptr) + (_OFF(ptr) >> 4) ) + (void near *)(_OFF(ptr) & 0x000F) )

#define HiByte( val )   ((byte *)(&val))[1]
#define LoByte( val )   ((byte *)(&val))[0]
#define HiWord( val )   ((word *)(&val))[1]
#define LoWord( val )   ((word *)(&val))[0]


// । 楤 ࠡ⪨ 뢠
// -----------------------------------------
typedef void (interrupt far *InterruptPtrPar)( int bp, int di, int si,
					       int ds, int es, int dx,
					       int cx, int bx, int ax );
typedef void (interrupt far *InterruptPtr)( void );

// :
// cli                    -  뢠
// sti                    - ࠧ 뢠
// _int( n )              - ஢ 뢠
// GetVec( IntPtr, nVec ) -   뢠
// SetVec( IntPtr, nVec ) - ⠭  뢠
// GetSetVec( nVec, OldPtr, NewPtr ) - ⠭ ࠡ稪 뢠
// ---------------------------------------------------------------------
c_type void __emit__( unsigned char __byte, ... );
#define     cli             __emit__(0xFA)
#define     sti             __emit__(0xFB)
#define     _int( n )       __emit__(0xCD, n)

#define	GetVec( IntPtr, nVec )            {\
                      cli;\
					  _ES = 0;\
					  _BX = nVec*4;\
					  IntPtr = *( InterruptPtr _es *)_BX;\
					  sti;\
                                          }
#define SetVec( nVec, IntPtr )            {\
                      cli;\
					  _ES = 0;\
					  _BX = nVec*4;\
					  *( InterruptPtrPar _es *)_BX = IntPtr;\
					  sti;\
					  }
#define RestVec( nVec, IntPtr )           {\
                      cli;\
					  _ES = 0;\
					  _BX = nVec*4;\
					  *( InterruptPtr _es *)_BX = IntPtr;\
					  sti;\
					  }
#define GetSetVec( nVec, OldPtr, NewPtr ) {\
                      cli;\
					  _ES = 0;\
					  _BX = nVec*4;\
					  OldPtr = *( InterruptPtr _es *)_BX;\
					  *( InterruptPtrPar _es *)_BX = NewPtr;\
					  sti;\
					  }
#ifndef     NULL
  #include <_null.h>
//  #define     NULL    (void far *)0L
#endif

#define         ON      1
#define         OFF     0

#define	 TimeCounter		*((dword far *)0x46CL)
#define	 KeyFlags   		*((word  far *)0x417L)

#endif

