;
; ணࠬ ஢ ०                                 
; ᪮ ࠢ (C) 1994 ਩ .⥪                        
;

; $Log: modetest.asm $
; Revision 1.4  1997/08/12 10:26:06  GLASS
; -    ⠫ ஥.
;
; Revision 1.3  1996/10/14 16:34:54  GLASS
; -  ࠭ CRC  Video BIOS;
; -  ⮡ࠦ ᥣ ;
; -  ⮡ࠦ  ஢;
;
; Revision 1.2  1996/05/30 17:58:40  GLASS
; -  ࠭  ⠭ .
;
; Revision 1.1  1996/05/25 04:23:50  GLASS
; Initial revision
;

       include support.inc
       include control.inc
       include global.inc
       include constant.inc
       include bios40.inc
       include modetest.inc
       include version\xgaver.inc

.data
;ͻ
; 饭 
;ͼ

msgTitle    DB  "VGA Video mode Test and Information. Version 2.00",CR,LF
            DB  "Copyright (C) 1996 Dmitry A.Steklenev",CR,LF,CR,LF,0

msgHelp     DB  "Usage: MODETEST <database>" ,CR,LF
            DB  "       or"                  ,CR,LF
            DB  "       MODETEST /Test"      ,CR,LF,0

msgProg     DB  "MODETEST" ,0
msgDos      DB  "DOS"      ,0

msgHeapMode DB  "mode type    cols rows char  colors start", 0
msgHeapLine DB  "==== ======= ==== ==== ===== ====== =====", 0

msgGraphic  DB  "Graphic "     ,0
msgText     DB  "Text    "     ,0

msgPause    DB  "Press any key to continue...",CR,0
msgPauseDel DB  "                            ",CR,0
msgTest     DB  "Testing video mode: "        ,   0
msgSupport  DB  "- SUPPORTED!"                ,   0
msgHome     DB  CR,0

argTest     DB  "TEST",0

errVGA      DB  "Not VGA or SVGA card presented"                ,CR,LF,0
errGraph    DB  "This program can't run in graphics mode"       ,CR,LF,0
errWindow   DB  "This program can't run in windowed mode"       ,CR,LF,0


;ͻ
;   
;ͼ

VH struc                ;  
   sig      DW  "MV"    ; ᨣ (VM)
   release  DW  XGA_VMD ; 
   bioscrc  DD  0       ; CRC32  Video BIOS
   oemsize  DW  0       ;  ப OEM
ends

dbHeadLen = type VH

VM struc          ;ᠭ ०:
   mode   DB  0   ; 
   graph  DB  0   ; ᪨
   cols   DW  0   ; 
   rows   DW  0   ; ⮫殢
   char   DB  0   ; ࠧ ᨬ
   color  DW  0   ; ᫮ 梥⮢
   memseg DW  0   ; ᥣ 砫 
ends

dbRecLen  =   type VM

VB struc              ; Video BIOS
   biossig DW 0AA55h  ; ᨣ
   bioslen DB 0       ;   512 ⮢ 
ends

;-----------------------------------;
strMode   DB  "0000 "   ,0          ; ०
strReso   DB  "0000 "   ,0          ; 襭
strColor  DB  "000000 " ,0          ; ᫮ 梥⮢
strFont   DB  "08x00 "  ,0          ;  ᨬ
strMemSeg DB  "00000 "  ,0          ;  
;-----------------------------------;
scrBottom DB  0                     ; ᫮ ப  ࠭
scrRow    DB  0                     ; ᫮ 뢥 ப
;-----------------------------------;
curMode   DB  0                     ; 騩 ०
curScreen DD  0                     ; 騩 ࠭
curPos    DW  0                     ;   
curShape  DW  0                     ;  ଠ 
curState  DD  0                     ; ⥫  ⥪饥 ﭨ
;-----------------------------------;
dbFile    DB  256 dup (0)           ;     
dbName    DB  "MODETEST.DAT",0      ;  䠩  
dbHandle  DW  0                     ;   
dbHeader  VH  <>                    ;   
dbRecord  VM  <>                    ;   
;-----------------------------------;
vbEntry   DD  0C0000003h            ;  楤 樠樨 BIOS
;-----------------------------------;

SAVE_FLAGS = 4

.code
.startup
;ͻ
;  楤                                                    
;ͼ
testMain proc near

  call  _scrFrame             ;  ᫥ ப
  mov   scrBottom,dh          ; ࠭.

  @out  msgTitle              ;뢥 ᪨ ࠢ.
  mov   scrRow,3              ;( ? ப  ᯫ).

  call  _prgArg?              ;᫨ ணࠬ 饭  㬥⮢,
  @if   ax == 0               ;뢥  ࠭ ᪠.
        @out  msgHelp
        @quit 0
  @endif

  @if   ax ++ 1               ;᫨ ணࠬ ।  
        @err EC_NUMARG        ;㬥, 뢥 ᮮ饭  ୮
  @endif                      ;⢥ 㬥⮢.

  call  _prgArg               ; 㪠⥫  ⨯ 㬥.

  @if   al == PA_SWITCH
        @if <cl == 1> and <@byte(si) == '?'>
            @out  msgHelp
            @quit 0
        @endif

        @if cl -= 4           ;஢ઠ  /Test
            lea di,argTest
            rep cmpsb
            @if ZF == 0
                @err  EC_INVARG
            @endif
            jmp short @@test
        @else
            @err  EC_INVARG
        @endif
  @else
        lea di,dbFile         ;஢  䠩 
        rep movsb             ; 쭥襣 ᯮ짮.
        jmp @@show
  @endif

@@test:

  call  _scrEquip
  @if   <al #= SE_VGA> and <al #= SE_VGA_MONO>
        @err ,,,errVGA        ;ணࠬ ।祭 ⮫쪮 
  @endif                      ;ࠡ  VGA  SVGA.

  call  _scrGraphics          ;ணࠬ   ⮢ 
  @if   al == TRUE            ;᪮ ०.
        @err ,,,errGraph
  @endif

  @int 4010h,2Fh              ;ணࠬ   ⮢
  @if  ax #= 4010h            ;  ० OS/2
       @outb 03D6h,82h
       in    al,dx
       @if   al == 0
             @err ,,,errWindow
       @endif
  @endif

  call  _prgPath              ;  㯠  ⥪饩
  push  ds                    ;ணࠬ, ⠬  㤥 ࠧ
  mvx   ds,es                 ; 䠩 .
  mov   si,di
  mvx   es,cs
  lea   di,dbFile
  rep   movsb                 ;஢ .
  pop   ds
  lea   si,dbName
  call  _strCopy              ;   .

  lea   dx,dbFile             ; 䠩 .
  xor   cx,cx
  @int  3Ch,21h
  @if   CF == 1
        @err  EC_OPEN,ax,,,dbFile
  @endif
  mov   dbHandle,ax           ;࠭ .

  call  GetBiosCRC            ; CRC 
  sdx   dbHeader.bioscrc      ;Video BIOS.

  mov   bx,dbHandle           ;   .
  lea   dx,dbHeader
  mov   cx,dbHeadLen
  @int  40h,21h
  @if   CF == 1
        @err  EC_WRITE,ax,,,dbFile
  @endif

  call  saveMode              ;࠭ ०

; push  ax bx cx dx di si ds es bp
; call  [vbEntry]
; pop   bp es ds si di dx cx bx ax
; mov   ax,1000
; call  _delay

  xor   ax,ax                 ;஢ 㯭
  @for  127                   ;०.

        @if <al -- 7> or <al ++ 12>

            push ax           ;뢥 ଠ 
            @hcf ax strMode 4 ;㥬 ०.
            @out msgTest
            @out strMode
            @out msgHome
            mov  ax,50
            call _delay
            pop  ax
            call testMode
            @if  CF == 0        ;᫨ ० ন
                 push ax        ;஬,  ଠ
                 call restMode  ; ⪮ "SUPPORTED!"
                 @out msgTest
                 @out strMode
                 @out msgSupport
                 @out msgHome
                 mov  ax,500    ;ਤঠ ࠦ, ⮡
                 call _delay    ;ᬮ騩 ᯥ ࠤ.
                 call restMode
                 pop  ax
            @else
                 call restMode
            @endif
        @endif
        inc al
  @next

  call  restMode              ;⠭ ०
  mov   bx,dbHandle           ; 䠩 .
  @int  3Eh,21h

@@show:

  lea   dx,dbFile             ; 䠩   ⥭.
  xor   cx,cx
  @int  3D20h,21h
  @if   CF == 1
        @err  EC_OPEN,ax,,,dbFile
  @endif
  mov   dbHandle,ax           ;  䠩.
  mov   bx,ax

  lea   dx,dbHeader           ;஢  䠩
  mov   cx,dbHeadLen          ;.
  @int  3Fh,21h
  @if   CF == 1
        @err  EC_READ,ax,,,dbFile
  @endif
  @if   <dbHeader.sig #= "MV"> or <dbHeader.release #= XGA_VMD>
        @err EC_FORMAT,,,,dbFile
  @endif

  @out  msgHeapMode           ;뢥 蠯 ⠡.
  call  eject
  @out  msgHeapLine
  call  eject

  @repeat
    lea  dx,dbRecord          ; ।  
    mov  cx,dbRecLen          ;.
    @int 3Fh,21h
    @if  CF == 1
         @err  EC_READ,ax,,,dbFile
    @endif
    @exit ax #= dbRecLen

    call  showMode            ; ଠ  ०.
  @always

  @quit 0
endp

;ͻ
; ࠭ ﭨ                                                  
;ͼ
saveMode proc near uses ax bx cx dx di si es bp

  @int  0Fh,10h               ;  ࠭ ⥪騩
  mov   curMode,al            ;०.

  call  _scrFrame             ;। ࠧ ࠭,
  call  _scrSize              ;뤥    ࠭
  call  _memGrab              ;ᮤন ࠭.
  mov   @high(curScreen),ax
  push  ds
  mov   ds,ax
  xor   si,si
  call  _scrSave
  pop   ds

  call  _scrGetPos            ;  ࠭ 
  mov   curPos,dx             ;  .
  call  _scrGetCursor
  mov   curShape,ax

  mov   cx,SAVE_FLAGS         ; ࠧ , ॡ饣
  @int  1C00h,10h             ; ࠭ ﭨ ( 64-
  @if   al #= 1Ch             ;).
        ret                   ;᫨ 㭪  ন,
  @endif                      ; ࠢ.

  shl   bx,6                  ;뤥  室 
  mov   ax,bx                 ;࠭ ﭨ.
  call  _memGrab
  mov   @high(curState),ax

  les   bx,curState           ;࠭ ﭨ.
  mov   cx,SAVE_FLAGS
  @int  1C01h,10h

  ret
endp

;ͻ
; ⠭ ﭨ                                               
;ͼ
restMode proc near uses ax bx cx dx di si es bp

  @if   @high(curState) #= 0
        les  bx,curState
        mov  cx,SAVE_FLAGS
        @int 1C02h,10h
  @endif

  mov   al,curMode            ;⠭ ०.
  @int  00h,10h

  call  _scrFrame             ;⠭ ᮤন ࠭ 
  push  ds                    ;᢮ 㦭 ⥯ 
  lds   si,curScreen          ;.
  call  _scrRest
  mov   ax,ds
  pop   ds
  call  _memFree

  mov   dx,curPos             ;⠭   
  call  _scrSetPos            ;.
  mov   ax,curShape
  call  _scrSetCursor
  ret
endp

;ͻ
;  ଠ  ०                                    
;ͼ
testMode proc near Uses ax bx cx dx di si ds es
  local state:VM, vgainfo:byte:128

  push ax

  push ax bx cx dx di si ds es bp
  @int 00h,10h                ;⠭ ஢塞 ०.
  pop  bp es ds si di dx cx bx ax
  cld

  @int 0Fh,10h                ; ०,  稫
  mov  state.mode,al          ; १.
  and  state.mode,7Fh         ;  襣  (Bug S3 Trio64+)
  call _scrGraphics           ; ਧ ᪮ ०.
  mov  state.graph,al
  call _scrFrame              ;࠭ ᫮ ப  ᫮
  add  dx,101h                ;⮫殢.
  mov  al,dh
  mov  ah,0
  mov  dh,0
  mov  state.cols,dx
  mov  state.rows,ax
  push ds
  mvx  ds,40h
  mov  ax,ds:_bios_CharHeight
  pop  ds
  mov  state.char,al

  cli                         ; 76543210
  mov  dx,3CEh                ;             
  mov  al,06h                 ; ҽ bit
  out  dx,al                  ;          ˼   0: 1=graphics; 0=enable char gen (text)
  inc  dx                     ;              1: 1=chain odd maps after even maps
  in   al,dx                  ;            2: memory mapping for CPU
  sti                         ;                       00=a000H (128K);   01=a000H (64K)
  and  al,1100b               ;                       10=b000H (32K MDA);11=b800H (32K CGA)

  @if  al == 0000b            ;   砫
       mov bx,0A000h          ; .
  @elseif al == 0100b
       mov bx,0A000h
  @elseif al == 1000b
       mov bx,0B000h
  @elseif al == 1100b
       mov bx,0B800h
  @endif
  mov  state.memseg,bx

  mvx  es,ss                  ; ⥫ ଠ 
  xor  bx,bx                  ;०   㤠 ᫮ 梥⮢.
  lea  di,vgainfo
  @int 1Bh,10h
  mvx  state.color,es:[di+27h]

  pop  ax

  @if  al == state.mode       ;᫨ ० ⠭,
       lea  dx,state          ; ଠ     .
       mov  cx,dbRecLen
       mov  bx,dbHandle
       @int 40h,21h
       @if  CF == 1
            @err  EC_WRITE,ax,,,dbFile
       @endif
       clc
  @else
       stc
  @endif
  ret
endp

;ͻ
; ⮡ࠧ ଠ  ०                                  
;ͼ
showMode proc near Uses ax bx cx dx di si ds es

  mov  al,dbRecord.mode          ;뢥  ०.
  xor  ah,ah
  @hcf ax strMode 4
  @out si

  @if  dbRecord.graph == TRUE
       @out msgGraphic
  @else                          ;뢥 ⨯.
       @out msgText
  @endif

  @if  dbRecord.graph == FALSE
       mov  ax,dbRecord.cols     ;뢥 ᫮ ⮫殢.
       @dcv ax strReso 4
       @out strReso

       mov  ax,dbRecord.rows     ;뢥 ᫮ ப.
       @dcv ax strReso 4
       @out strReso
  @else
       mov  ax,dbRecord.cols     ;뢥 ࠧ襭 
       mov  bx,8                 ;ਧ⠫.
       mul  bx
       @dcv ax strReso 4
       @out strReso

       mov  ax,dbRecord.rows     ;뢥 ࠧ襭 
       mov  bl,dbRecord.char     ;⨪.
       xor  ah,ah
       mul  bx
       @dcv ax strReso 4
       @out strReso
  @endif

  mov  al,dbRecord.char     ;뢥 ࠧ .
  xor  ah,ah
  @dcf ax strFont[3] 2
  @out strFont

  mov  ax,dbRecord.color    ;뢥 ᫮ 梥⮢.
  @dcv ax strColor 6
  @out strColor

  mov  ax,dbRecord.memseg   ;뢥  ᥣ 
  @hcf ax strMemSeg 5       ;
  @out strMemSeg

  call eject
  ret
endp

;ͻ
;  CRC Video BIOS                                              
;ͼ
GetBiosCRC proc near uses bx cx ds es di si

  local vbHeader:VB

  push  ds                        ;  Video BIOS.
  mvx   es,ds
  lea   di,vbHeader
  xor   si,si
  mvx   ds,0C000h
  mov   cx,type VB
  call  _memCopy
  pop   ds

  @if   vbHeader.biossig == 0AA55h

        mov  al,vbHeader.bioslen  ; ࠧ BIOS 
        xor  ah,ah                ;.
        mov  bx,512
        mul  bx

        push ax                   ;뤥    ᪮஢
        call _memGrab             ;  BIOS.
        mov  es,ax
        xor  di,di
        pop  cx
        push ds
        mvx  ds,0C000h
        xor  si,si
        call _memCopy

        mvx  ds,es                ; CRC32, ࠭  
        mov  si,di                ;᢮ .
        mov  ax,-1
        mov  dx,ax
        call _crc32
        pop  ds
        push dx ax
        mov  ax,es
        call _memFree
        pop  ax dx
  @else
        xor  ax,ax
        mov  dx,ax
  @endif
  ret
endp

;ͻ
; ॢ ப                                                       
;ͼ
Eject proc near uses ax bx cx dx di si ds es

  call _dosEject  ;ॢ ப 
  inc  scrRow     ;㢥 稪 ப.

  mov  ah,scrRow
  @if  ah == scrBottom
       call _dosReDirect?
       @if  al == FALSE
            @out msgPause
            @int 0,16h
            @out msgPauseDel
            mov  scrRow,0
       @endif
  @endif

  ret
endp

end @Startup
