/***********************************************************************
  : PATCHER.CPP
  ᪮ ࠢ (C) 26/07/95 ਩ .⥪
***********************************************************************/

// $Log: patcher.cpp $
// Revision 1.10  1997/07/01 22:46:12  GLASS
// -  뢠  ᪠஢, ᮮ饭 뢮  ୠ
//    ஢ન  ⢮. 䨪ᥭ.
//
// Revision 1.9  1997/06/30 22:16:16  GLASS
// - ࠢ 訡  楤  : ᫨ 
//    稢 㤠祩,  㪠⥫ ⥭ ⠢
//    ᠭ ,    砫 ᫥饩.
//
// Revision 1.8  1996/12/12 14:14:31  GLASS
// -  ᪠஢ ᪮ ⮡ࠦ ⮫쪮  ⠫. 
//   ᪮ ࠡ ࠧ  ;
// -  ࠡ⪠ 뢠 ࠡ 짮⥫  
//    ESCAPE.
//
// Revision 1.7  1996/06/20 15:11:02  GLASS
// -     䠩   蠡.  ⮬
//     ⢮  ᠭ,  .
//
// Revision 1.6  1996/05/25 04:24:52  GLASS
// -  ஢ઠ  訡  ᬥ ⠫.
//
// Revision 1.5  1996/01/08 04:02:47  GLASS
// - ࠢ 訡  ⮡ࠦ ⨪
//
// Revision 1.4  1996/01/03 20:05:38  GLASS
//   ⪠   /undo
//
// Revision 1.3  1995/12/18 18:02:44  GLASS
// ࠢ 訡  १ࢭ ஢ 䠩  ७.
//
// Revision 1.2  1995/12/15 21:11:55  GLASS
//   ॡ ⢥ত  짮⥫
// ।   (ਠ *file?).   㢥祭
//  20 .
//
// Revision 1.1  1995/12/15 17:47:49  GLASS
// Initial revision
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <process.h>
#include <ctype.h>
#include <dir.h>
#include <dos.h>
#include <io.h>
#include <bios.h>
#include <conio.h>

#include "error.hpp"

/***********************************************************************
  
***********************************************************************/

extern unsigned _stklen = 20480;

/***********************************************************************
  饭
***********************************************************************/

const char *msgTitle = "Patcher Version 1.32. Copyright (C) 1995-1997 Dmitry A.Steklenev\n";
const char *msgHelp  = "Usage: PATCHER definition [report] [/undo]\n";
const char *msgLine  = "-----------------------------------------------------------------------------";

const char *msgProg  = "PATCHER";
const char *msgRead  = "Reading file names...";

const char *msgSynt  = "Syntax error";
const char *msgFile  = "Too many files definitions";
const char *msgByte  = "Too many bytes definitions";

const char *fixAcces = "%-12s - Acces denied\n";
const char *fixFixed = "%-12s - Fixed %u of %u\n";
const char *fixUndo  = "%-12s - Undo %u of %u\n";
const char *fixBack  = "%-12s - Backup create error\n";

/***********************************************************************
  
***********************************************************************/

char  *deffile = NULL;    //  䠩 ᠭ
FILE  *hd;                //  䠩 ᠭ

char  *repfile = NULL;    //  䠩 
FILE  *hr;                //  䠩 

int   undo = 0;           // ਧ ⠭ .

// ६ defline  defseek ।  ப   ᬥ饭
//  䠩 ᠭ. 祭  ६ ⠭ 㭪樨
// getline(), getundo(), getgoto():

long  defline = 0;        //  ப  䠩 ᠭ
long  defseek = 0;        // 砫 ⥪饩 ப  䠩 ᠭ

//  䠩 ᠭ  *FILE  䠩 ᠭ, ࠧ
// 㭪樥 createDefList()   filelist:

struct filelist {         //  ᠭ 䨪㥬 䠩:
  char name[80];          //  䠩,
  char wildcart;          // ᨬ 蠡   䠩,
  long size;              // ࠧ 䠩,
  long line;              //  ࢮ ப ᠭ (᫥ *FILE),
  long seek;              // 㪠⥫  砫 ப  䠩 ᠭ.
  int  confirm;           // 訢 ⢥ত 짮⥫?
};

const int scanmax = 500;  // ᨬ쭮 ⢮ 䠩.
filelist *scanptr = NULL; // ⥫  ᨢ ᠭ 䠩.
      int scanlen = 0;    //  ᨢ ᠭ.

//  ᠭ  䠩 ᠭ  䨪㥬 䠩, ࠧ
// ।⢥ ।    bytelist.

struct bytelist {         //  ᠭ ࠣ :
  long seek;              //   䠩,
  char oldbyte;           // ஥ 祭 ,
  char newbyte;           //  祭 .
};

const int bytemax = 8192; // ᨬ쭮 ⢮  .
bytelist *byteptr = NULL; // ⥫  ᨢ ᠭ .
      int bytelen = 0;    //  ᨢ ᠭ .

const int buffmax = 8192; //    뢮
char     *buffptr = NULL; // ⥫    뢮.
      int bufflen = 0;    //    .

      int backup  = 0;    // ਧ ᮧ १ࢭ 
                          // 䠩.

const int maxline = 256;  // ᨬ쭠  ப  䠩 ᠭ.
const int maxpath = 256;  // ᨬ쭠     䠩.

long  lookdisk = 0;       // ᬮ७ 䠩.
long  lookfile = 0;       // ᬮ७ 䠩.
long  findfile = 0;       //  䠩.

enum lextype { LN_FILE,   //  ப  䠩
               LN_BYTE,   // ᠭ.
               LN_TEXT,
               LN_EOF   };

void errgen( const char *subname,         //  ⥬
             errtype     type,            // ⨯ 訡
             errcode     code,            //  訡
             const char *message = NULL,  // ᠭ 訡
             long        line = 0,        // ப  䠩 ᠭ
             const char *object = NULL ); // ꥪ 訡

/***********************************************************************
  㭪:    memgrab
  ࠬ:      
  頥: ⥫  뤥  
************************************************************************/
void *memgrab( int size )
{
  void *memptr = malloc( size );              // 뤥  .
  if( memptr == NULL )                        //  㤠, ஢
    errgen( msgProg, ET_FATAL, EC_MEMLOW );   //  訡.
  return memptr;
}

/***********************************************************************
  㭪:    memfree
  ࠬ:   , 뤥 memgrab()
************************************************************************/
void memfree( void *memptr )
{
  if( memptr != NULL ) free( memptr );
}

/***********************************************************************
  㭪:    quit
  ࠬ:   襭 .
************************************************************************/
void quit( int exitcode )
{
  memfree(scanptr);     // ᢮  .
  memfree(byteptr);
  memfree(buffptr);

  if( exitcode == 0 )   //  ଠ쭮 襭 뢥
  {                     //  ࠭ ⨪.

    printf( "\n" );
    printf( "%12lu disk(s) looked\n", lookdisk );
    printf( "%12lu file(s) looked\n", lookfile );
    printf( "%12lu file(s) found\n" , findfile );
  }

  exit( exitcode);
}

/***********************************************************************
  㭪:    putstate
  頥: 
  ࠬ:  ப  뢮
  ᠭ:    ப  ᮫,  ।  頥
               砫 ப.
************************************************************************/
void putstate( const char *str )
{
  char dsp[maxline];        //   ࠧ饭 ப.
  static int oldlen = 0;    //  ᫥ ᮮ饭.
  int newlen = strlen(str); //   ᮮ饭.

  printf( "%s", str );
  while( oldlen-- > newlen ) printf( " " );
  printf( "\r" );
  oldlen = newlen;
}

/***********************************************************************
  㭪:    error
  頥: 
  ࠬ:  ⥯ 쥧 訡, ᮮ饭,  䠩,
               ப.
  ᠭ:   뢮 ᮮ饭: severity: message [file: file],
                                                   [line: line]
               ⠫쭮 訡 뢠 quit(1).
************************************************************************/
void errgen( const char *subname, errtype    type,
                                  errcode    code,
                                  const char *message,
                                  long       line    ,
                                  const char *object )
{
  error err( subname );

  err.type = type;        // ⨯  訡
  err.code = code;        //  ⥬ 訡
  err.message = message;  // ᮮ饭
  err.subcode = line;     // ப  䠩 ᠭ
  err.object  = object;   // ꥪ 訡

  if( code != EC_NONE )   // ᫨ 㪠 ⥬  訡,
    err.subcode = code;   // ⠢   subcode.

  putstate("");           //  ப ﭨ 
  err.gen();              // ᣥ஢ 訡.

  if( type == ET_FATAL )  // ᫨ 訡 ⠫쭠,
    quit(1);              //  ࠡ ணࠬ.
}

/***********************************************************************
  㭪:    reportf
  頥: 
  ࠬ:  蠡  뢮  ...
  ᠭ:    ப  䠩 , ᫨ ᫥ 
************************************************************************/
void reportf( const char *format, const char *s1 = NULL,
                                  const char *s2 = NULL,
                                  const char *s3 = NULL,
                                  const char *s4 = NULL  )
{
  if( hr != NULL )
    fprintf( hr, format, s1, s2, s3, s4 );
}

/***********************************************************************
  㭪:    getline
  頥: ᪨ ⨯ ப
  ࠬ:  ६  ࠧ饭 ப (  maxline ᨬ)
  ᠭ:    ப  䠩 ᠭ, ய᪠ ப,
              稭騥 c '//'.  ᨬ ॢ ப.
************************************************************************/
lextype getline( char *line )
{
  while(!feof(hd))
  {
    defseek = ftell( hd );              //    ⪠.
    line[0] = 0;                        //  ப.
    fgets( line, maxline-1, hd );       //  ப.
    ++defline;
    *strchr( line, '\n' ) = 0;          //  ᨬ ॢ
                                        // ப.
    if( strstr( line, "//" ) == line )  // ᫨  ਩,
      continue;                         // ३  ᫥饩 ப.

    if( line[0] == '*'  )               // ᫨ ப 稭  '*',
    {                                   //  .
      strupr( line );

      if( strncmp( "*FILE", line, 5 ) == 0 )
        return LN_FILE;                 //  *FILE
        return LN_BYTE;                 //  ᠭ *XXXX: XX XX
    }
    return LN_TEXT;                     //  ⥪.
  }
  return LN_EOF;                        //  䠩.
}

/***********************************************************************
  㭪:    getundo
  頥: void
  ᠭ:   ந ⪠   ப 䠩 ᠭ .
************************************************************************/
void getundo()
{
 fseek( hd, defseek, SEEK_SET );
 --defline;
}

/***********************************************************************
  㭪:    getgoto
  頥: void
  ᠭ:   ந 室   ப 䠩 ᠭ.
************************************************************************/
void getgoto( long seek, long line )
{
 fseek( hd, seek, SEEK_SET );
 defline = line;
}

/***********************************************************************
  㭪:    hextol
  ᠭ:    hex ப  long
************************************************************************/
long hextol( char *pos )
{
  long  exp = 0;
  char *i = pos;

  while( isspace( *i )) ++i;
  while( *i != 0 )
  {
        if(  isdigit(*i)) exp = exp * 16 + (*i - '0');
   else if( isxdigit(*i)) exp = exp * 16 + (*i - 55 );
        else break;
   ++i;
  }
  return exp;
}

/***********************************************************************
  㭪:    getpatch
  頥: 1 -  ଠ쭮 ࠧ, 0 -  訡
  ᠭ:    ६ byte
************************************************************************/
int getpatch( char *str, char *dlm, long &exp )
{
  char *pos;

  if(( pos = strtok( str, dlm )) == NULL )
  {
    errgen( deffile, ET_ERROR, EC_NONE, msgSynt, defline );
    return 0;
  }
  exp = hextol( pos );
  return 1;
}

/***********************************************************************
  㭪:    preparepatch
  頥: 1 -  ଠ쭮 ࠧ, 0 -  訡
  ᠭ:    ᨢ byteptr
************************************************************************/
int preparepatch()
{
  long seek, oldbyte, newbyte;              // ᠭ  .
  char str[maxline];                        // ப ᠭ.

  bytelen = 0;
  while( getline(str) == LN_BYTE )
  {
    if( !getpatch( str+1,  ":", seek    ))  //   䠩
      return 0;

    if( !getpatch( NULL, " \t", oldbyte ))  // ஥ 祭
      return 0;                             // .

    if( !getpatch( NULL, " \t", newbyte ))  //  祭
      return 0;                             // .

    byteptr[bytelen].seek = seek;

    if( undo )                              //  ⪠  
    {                                       // ⠬.
      byteptr[bytelen].oldbyte = (char) newbyte;
      byteptr[bytelen].newbyte = (char) oldbyte;
    }
    else
    {
      byteptr[bytelen].oldbyte = (char) oldbyte;
      byteptr[bytelen].newbyte = (char) newbyte;
    }

    if ( ++bytelen > bytemax )
      errgen( deffile, ET_FATAL, EC_NONE, msgByte, defline );
  }
  return 1;
}


/***********************************************************************
  㭪:    copyfile
  㬥:  ஢ 䠩
  頥: 0 -  ଠ쭮 襭, 1 -  訡
************************************************************************/
int copyfile( char *source, char *target )
{
  FILE *in, *out;
  ftime datetime;

  if((in = fopen( source, "rb" )) == NULL)
    return 0;

  if((out = fopen( target, "wb" )) == NULL)
    return 0;

  getftime( fileno(in), &datetime );

  while(( bufflen = fread( buffptr, 1, buffmax, in )) != 0 )
    fwrite( buffptr, 1, bufflen, out );

  fclose( in  );
  fclose( out );

  if((out = fopen( target, "rb" )) == NULL)
    return 0;
  setftime( fileno(out), &datetime );
  fclose(out);

  return (ferror(in) | ferror(out)) ? 0 : 1;
}

/***********************************************************************
  㭪:    backupfile
  㬥:  ᮧ १ࢭ  䠩
  頥: 0 -  ଠ쭮 襭, 1 -  訡
************************************************************************/
int backupfile( char *fullname )
{
  char name[maxpath];
  int  ext = -1, pos = 0;

  strcpy( name, fullname );           //  砫 ७ 
  while( name[pos] != 0 )             // 䨪㥬 䠩.
  {
    switch( name[pos] )
    {
      case ':' : ext = -1 ; break;
      case '\\': ext = -1 ; break;
      case '.' : ext = pos; break;
    }
    ++pos;
  }

  if( ext == -1 )
    ext = pos;

  name[ext] = 0;
  strcat( name, ".BAK" );             //  ७  .BAK
  return copyfile( fullname, name );  // ஢ 䠩.
}

/***********************************************************************
  㭪:    getYesNo
  頥: 1 -  ⨨ Y, 0 -  ⨨ N
  ᠭ:    ᨬ १ BIOS,  Y  N
************************************************************************/
int getYesNo()
{
  for(;;)
  {
    int key = bioskey(0);

    if( key << 8 == 0 )           // ᫨ ascii  㫥 - 
      continue;                   //  ७ .

    key = ( key << 8 ) >> 8;      //   ᪠-.

    if( 'Y' == key | 'y' == key )
      return 1;
    if( 'N' == key | 'n' == key )
      return 0;
  }
}

/***********************************************************************
  㭪:    placepatch
  頥: 1 -  ଠ쭮 ࠧ, 0 -  訡
  ᠭ:   뢠   byteptr  filename
************************************************************************/
int placepatch( char *name )
{
  FILE *io;
  int  i, fixed = 1;
  char byte;

  if((io = fopen( name, "r+b" )) == NULL)     //  䠩
  {                                           //  ० ⥭-.
    putstate("");
    printf( fixAcces, name );
    return 0;
  }

  for( i = 0; i < bytelen; i++ )              // ஢ ᮮ⢥⢨
  {                                           // ⮢  ᮤন
    fseek( io, byteptr[i].seek, SEEK_SET );   // 䠩.
    byte = fgetc(io);
    if(( byte != byteptr[i].oldbyte ) &       //  ⢨ ⠪
       ( byte != byteptr[i].newbyte ))        // ᮮ⢥⢨, 
       { fclose(io);                          // ᮮ饭  訡.
          return 0;
       }
    if(  byte == byteptr[i].oldbyte )         // ᫨  ਤ ,
       fixed = 0;                             // ⬥ .
  }
  if( !fixed )                                // ᫨  
  {                                           // 뢠, ᮧ
    if( !backup )                             // १ࢭ  䠩,
      if( !backupfile(name))                  // ᫨    ᮧ.
      {
        putstate("");
        printf( fixBack, name );
        fclose(io);
        return 0;
      }
      else
        backup = 1;

    for( i = 0; i < bytelen; i++ )              //  .
    {
      fseek( io, byteptr[i].seek, SEEK_SET );
      fputc( byteptr[i].newbyte, io );
    }
  }
  fclose(io);
  return 1;
}

/***********************************************************************
  㭪:    patchfile
  㬥:   䠩  ⥪饬 ⠫,   scanptr
  頥: void
************************************************************************/
void patchfile( char *fullname, int i )
{
  char str[maxline+1];                  //   ࠧ饭 ப
  char *name = fullname;                //  䠩
  int   count = 0, fixed = 0;
  char confirm[512];

  if( scanptr[i].confirm )
  {
    if( undo )
        sprintf( confirm, "%s - Undo file? [Y/N]", fullname );
    else
        sprintf( confirm, "%s - Patch file? [Y/N]", fullname );

    putstate( confirm );                  //  ⢥ত ,
    if( !getYesNo())                      // ᫨ ⠪  祭,
       return;                            // ய .
  }

  reportf( "%s\n%s\n", msgLine, fullname );
  getgoto( scanptr[i].seek, scanptr[i].line );

  while( getline(str) == LN_TEXT )        // 뢥   ᠭ
    reportf( "%s\n", str );               // 䠩.

  getundo();                              // ⪠ .
  backup = 0;                             //  ਧ १ࢭ
                                          // ஢ 䠩.
  for(;;)
  {
    if( preparepatch())                   // ⮢ .
    {
      ++count;                            //  ᫮  
      getundo();                          // ⪠ .

      if( placepatch(name))
      {
        ++fixed;                          //  ᫮ 
        while( getline(str) == LN_TEXT )  //   뢥  䠩 ᠭ
          reportf( "%s\n", str );         // .
      }
      else
      {
        while( getline(str) == LN_TEXT ); // ய ᠭ .
      }

      getundo();                          // ⪠ .
    }
    else
      break;

    if( getline(str) == LN_BYTE )         // ᫨ ᫥ ᠭ
    {                                     //    ।,
      getundo();                          // த ࠡ.
      continue;
    }

    putstate("");
    printf( fixFixed, name, fixed, count );
    break;
  }
}

/*-----------------11/02/96 16:16-------------------
 * ஢ઠ ᮮ⢥⢨ ப  蠡
 *--------------------------------------------------*/
short wildequ( char *pattern, char *src )
{
  char *patptr = pattern;
  short patlen = strlen(pattern);
  char *srcptr = src;
  short srclen = strlen(src);

  /*  ப   ᮢ   祬 */
  if ( patlen == 0 | srclen == 0 ) return 0;

  char patchr = *patptr;

  while( patlen && srclen )
  {
    if ( patchr == '*' )
    {
      /* ᫨ '*' ᫥ ᨬ  蠡, ࠢ
       * ⠥ ᯥ   ப
       */

      if ( patlen == 1 ) return 1;

      /* ᫨  ᫥騩 ᨬ 蠡 ᫥ '*',
       * ३  
       */

      if( *(patptr+1) == *srcptr )
      {
        patchr = *(++patptr);
        --patlen;
      }
      else
      {
        ++srcptr;
        --srclen;
        continue;
      }
    }

    if( patchr != '?' & patchr != *srcptr )
      return 0;

    ++patptr; --patlen;
    ++srcptr; --srclen;

    patchr = *patptr;

    /* ᫨ '*' ᫥ ᨬ  蠡, ࠢ
     * ⠥ ᯥ   ப
     */

    if ( patlen == 1 & patchr == '*' ) return 1;
  }
  return ( patlen == 0 & srclen == 0  );
}

/***********************************************************************
  㭪:    scanfile
  㬥:   䠩  ⥪饬 ⠫
  頥: void
  ᠭ:   ନ   䠩.   䠩  ᯨ᪥ scanptr,
              ஢  ࠧ.  砥 ᮢ 뢠 楤
               .
************************************************************************/
void scanfile( char *filename )
{
  char  fullname[maxpath];          // ନ஢   䠩:

  fullname[0] = getdisk() + 'A';    //  ன⢠,
  fullname[1] = ':' ;               // ࠧ⥫ ன,
  fullname[2] = '\\';               // ਧ ୥ ⠫,
  getcurdir( 0, fullname+3 );       // ⥪騩 ⠫,

  int msglen = strlen( fullname );  // ᫨ ⥪騩 ⠫ 
  if( msglen > 3 )                  // 㫥,  ࠧ⥫
  {                                 // ⠫ ।  䠩,
      fullname[msglen]   = '\\';
      fullname[msglen+1] = 0;
  }

  strcat( fullname, filename );     //   䠩.
  ++lookfile;                       //  㢥 稪 䠩.

  for( int i = 0; i < scanlen; i++ )
  {
    if ( scanptr[i].wildcart )      //  䠩   蠡.
    {
      if ( wildequ( scanptr[i].name, filename ))
      {
        patchfile( fullname, i );
        ++findfile;
      }
    }
    else
    {
      if( strcmp( scanptr[i].name, filename ) == 0 )
      {
        FILE *hand = fopen( filename, "rb" );
        if( hand == NULL )
          break;

        fseek( hand, 0, SEEK_END );     //  䠩   
        long size = ftell( hand );      // ࠧ.
        fclose( hand );

        if( scanptr[i].size == size )   // ᫨ ࠧ ᮢ,
        {                               // 맢 楤 ࠢ
          patchfile( fullname, i );     // 䠩.
          ++findfile;
        }
      }
    }
  }
}

/***********************************************************************
  㭪:    scandir
  㬥:  ⠫  砫 ᪠஢
  頥: void
  ᠭ:   ४ᨢ ᪠ 㪠 ⠫, ६  ६
              뢠 scanfile  䠩.
************************************************************************/
void scandir( char *startdir )
{
  char  curdir[maxpath] = "\\";   // 騩 ⠫.
  ffblk findstate;                // ﭨ ᪠.
  int   found;                    // ਧ  䠩.
  char  key;                      //  ᨬ

  getcurdir( 0, curdir+1);        // ࠭ ⥪騩 ⠫.
  if ( chdir( startdir ) != 0 )   //  ⠫  .
    return;

  char  fullname[maxpath];          // ନ஢   ⠫:

  fullname[0] = getdisk() + 'A';    //  ன⢠,
  fullname[1] = ':' ;               // ࠧ⥫ ன,
  fullname[2] = '\\';               // ਧ ୥ ⠫,
  getcurdir( 0, fullname+3 );       // ⥪騩 ⠫,
  putstate( fullname );             // 뢥  ஢塞 ⠫.

  found = findfirst( "*.*", &findstate, FA_DIREC );
  while( !found )
  {

   if ( kbhit())                    // ࠡ⪠ 뢠 
   {                                //   ESCAPE.
      key = getch();
      if ( key == 27 )
      {
         putstate( "Do you wish to cancel the current operation? [Y/N]");
         if ( getYesNo() )
            throw (int)-1;
      }
      if ( !key )
        getch();
   }

   if( findstate.ff_attrib & FA_DIREC )   // ᫨ 㦥 ⠫ 
   {                                      //   㦥 
       if( findstate.ff_name[0] != '.' )  // '.'  '..', 맢
           scandir( findstate.ff_name );  // ᪠஢ ⮣
   }                                      // ⠫.
   else
   {
       scanfile( findstate.ff_name );     //  맢 ஢
   }                                      //  䠩.

   found = findnext(&findstate);  // ᪠ ᫥騩 䠩 
  }                               // ⠫.

  chdir( curdir );                // ⠭ ⥪騩 ⠫.
}

/***********************************************************************
  㭪:    scandisk
  頥: void
  ᠭ:   室  ᥬ ⪨ ᪠, 뢠 scandir 
              ୥ ⠫.
************************************************************************/
void scandisk()
{
  int   curdisk = getdisk(); // ࠭ ⥪騩 .
  char  *mapd = "X:.";       //  ⠪ ࠧ NetWare ⠢
                             //  PATH  ⥢ ᪠.

  for(char disk = 'A'; disk <= 'Z'; disk++)
  {
    _BX = disk - 'A' + 1;   //  ⨯ ன⢠  AX,
    asm {                   // 0-floppy,1-hard|cd-rom,15-none.
      mov  ax,0x4408
      int  0x21
    }

    if( _AX != 1 )          // ᫨  100%  ⪨,
      continue;             // ய .

    asm {                   //  ਡ
      mov  ax,0x4409        // ᪠.
      int  0x21
    }

    if( _DX == 0x1000 )     // ᫨  ⥢  CD-ROM,
    {                       // ஢    ࠩ
        _CX = disk - 'A';   // MSCDEX. (뢠  A: = 0).
        asm {
          mov ax,0x150B
          int 0x2F
        }
        if((_BX == 0xADAD) & (_AX != 0))  // ᫨  CD-ROM,
          continue;                       // ய .

                            // ᫨  ⢨⥫쭮 ⥢
        mapd[0] = disk;     // ᪠    PATH  X:.

        if( strstr( getenv("PATH"), mapd ) != NULL )
          continue;         // ᫨  ,   , ய.
    }
    ++lookdisk;             //  稪 ᪮.
    setdisk( disk-'A' );    //  ⪨  ⥪騬.
    scandir("\\");          // 맢 ᪠஢ 䠩.
  }

  setdisk( curdisk );       // ⠭ ⥪騩 .
}

/***********************************************************************
  㭪:    createDefList
  頥: void
  ᠭ:    ᨢ scanptr ᠭﬨ 䠩  䠩 ᠭ
************************************************************************/
void createDefList()
{
  char    str[maxline];   //   ࠧ饭 ப.
  lextype strtype;        // ⨯ ப
  long    size;           // ࠧ 䠩
  char    *pos;
  int     confirm;

  putstate( msgRead );                // 饭  ⥭ ᠭ.
  getgoto( 0, 0 );                    //   砫 䠩.

  while( (strtype = getline(str)) != LN_EOF )
  {
    if( strtype != LN_FILE )          // ᫨   ᠭ 䠩,
      continue;                       // ய ப.

    if( (pos = strchr( str, ':' )) == NULL )
      errgen( deffile, ET_FATAL, EC_NONE, msgSynt, defline );

    size = atol( pos+1 );             //  ࠧ 䠩.
    *pos = 0;                         // १ ப.

    if( str[5] == '?' )               // ᫨ ᯮ
    {                                 // ଠ  *FILE?,
       confirm = 1;                   //   ⮣ 䠩
       pos = str + 6;                 // ॡ ⢥ত
    }                                 // 짮⥫.
    else
    {
       confirm = 0;
       pos = str + 5;
    }

    pos = strtok( pos, " \t" );       //    䠩,
    while( pos != NULL )              // ய⨢  *FILE.
    {
      if( scanlen > scanmax )
          errgen( deffile, ET_FATAL, EC_NONE, msgFile, defline );

      strcpy( scanptr[scanlen].name, pos );   //  䠩,
      scanptr[scanlen].size = size;           //  ,
      scanptr[scanlen].seek = ftell(hd);      //   䠩 ᠭ,
      scanptr[scanlen].line = defline;        //  ப ⠬ .
      scanptr[scanlen].confirm = confirm;     // 訢 ⢥ত?.

      scanptr[scanlen].wildcart = ( strchr( pos, '*' ) != NULL ||
                                    strchr( pos, '?' ) != NULL );
      ++scanlen;
      pos = strtok( NULL, " \t" );
    }
  }
}

/***********************************************************************
  㭪:    main
  頥: void
  ࠬ:   䠩 ᠭ   䠩 . ᫨  䠩 
              ᪠, ᪠  .
************************************************************************/
void main( int argc, char *argv[] )
{

  char   str[maxline];  //    ப.
  date   today;

  printf( msgTitle );   // 뢥 .

  if( argc < 2  )       // ᫨  㪠 㬥,
  {                     // 뢥 ᪠   ࠡ.
    printf( msgHelp );
    quit(1);
  }

  for( int i = 1; i < argc; i++ )
  {
    strupr( argv[i] );
    if( argv[i][0] == '/' )
    {
      if( strncmp( "/UNDO", argv[i], 5 ) == 0 )
      {
        undo = 1;             // ᫨ '/UNDO', ⠭ 䫠 
        fixFixed = fixUndo;   //  ᮮ饭 "fixed"  "undo"
      }
      else
        errgen( msgProg, ET_FATAL, EC_INVARG, NULL, 0, argv[i] );
    }
    else
    {
      if( deffile == NULL )
        deffile = argv[i];
      else if( repfile == NULL )
        repfile = argv[i];
      else
        errgen( msgProg, ET_FATAL, EC_NUMARG );
    }
  }

  if( deffile == NULL )
      errgen( msgProg, ET_FATAL, EC_NUMARG );

  hd = fopen( deffile, "rt" );    //  䠩 ᠭ.
  if( hd == NULL )
    errgen( msgProg, ET_FATAL, EC_OPEN, NULL, 0, deffile );

  if( repfile != NULL )           // ᫨ 㪠 䠩 ,
  {                               //  (ᮧ) .
    hr = fopen( repfile, "at" );  // 뢥  ணࠬ  .
    if( hr == NULL )
      errgen( msgProg, ET_FATAL, EC_OPEN, NULL, 0, repfile );

    getdate( &today );
    fprintf( hr, "%sCreated: %u/%u/%u", msgTitle, today.da_day,
                                                  today.da_mon,
                                                  today.da_year );
    if( undo )
      fprintf( hr, " *** UNDO MODE ***" );

    fprintf( hr, "\n\n" );
  }

  // 뤥 :

  scanptr = (filelist *) memgrab( sizeof( filelist[scanmax] ));
  byteptr = (bytelist *) memgrab( sizeof( bytelist[bytemax] ));
  buffptr = (char *) memgrab( buffmax );

  // 뢥 :

  while( getline(str) == LN_TEXT )
    printf( "%s\n", str );

  int   curdisk = getdisk();    // ࠭ ⥪騩 .
  char  curdir[maxpath] = "\\"; // 騩 ⠫.
  getcurdir( 0, curdir+1);      // ࠭ ⥪騩 ⠫.

  try
  {
    createDefList();    //  ᨢ ᠭ 䠩.
    scandisk();         // ⪮४஢ 䠩.
  }
  catch ( int exno )    // ࠡ⪠ 뢠  ॡ
  {                     // ஫짮⥫.
    putstate("");

    if ( exno != -1 )
      throw;

    putstate("*** USER INTERRUPTED ***\n");
    if( hr != NULL )
        fprintf( hr, "*** USER INTERRUPTED ***\n" );
  }

  fclose( hd );         //  䠩 ᠭ , ᫨  
  if( hr != NULL )      // ,   䠩 .
      fclose( hr );

  setdisk( curdisk );   // ⠭ ⥪騩 .
  chdir( curdir );      // ⠭ ⥪騩 ⠫.
  putstate( "" );

  quit(0);
}
