;
; ணࠬ ନ஢  VESA Extension                           
; ᪮ ࠢ (C) 1994 ਩ .⥪                        
;

; $Log: vesainfo.asm $
; Revision 1.4  2000/05/15 11:00:09  GLASS
; fix: ⮡ࠦ ᫠ 梥⮢
;
; Revision 1.3  1996/01/03 20:00:48  GLASS
;  ⮡ࠦ ࠧ DAC,      A  B
;
; Revision 1.2  1995/12/28 19:12:06  GLASS
;  㧠  ஫ ࠭.  ७祭 뢮 
; 䠩, 㧠  ᯮ
;
; Revision 1.1  1995/12/28 18:05:13  GLASS
; Initial revision
;

       include Support.inc
       include Control.inc
       include Global.inc
       include Constant.inc
       include Vesa.inc

.data
;ͻ
; 饭 
;ͼ

msgTitle    DB  "VESA Extension BIOS Information. Version 1.11",CR,LF
            DB  "Copyright (C) 1994-2000 Dmitry A.Steklenev",CR,LF,CR,LF,0

msgNotVesa  DB  "VESA Extension BIOS not installed",CR,LF,0

msgVesaMode DB  "VESA Extension Modes (hex)",0
msgBiosMode DB  "BIOS Extended Modes (hex)" ,0

msgHeapMode DB  "mode tp color bios hdw cols rows     colors char  memory   maps pages winA winB", 0
msgHeapLine DB  "==== == ===== ==== === ==== ==== ========== ===== ======== ==== ===== ==== ====", 0

msgVersion  DB  "VESA Version: ",0
msgFactory  DB  "Manufactured: ",0
msgRamSize  DB  "VideoRAM, KB: ",0
msgDACWidth DB  "   DAC Width: ",0

msgDACSwtch DB  "switchable"    ,0
msgDAC6bits DB  "6 bits"        ,0

msgGraphic  DB  "Gr "           ,0
msgText     DB  "Tx "           ,0
msgColor    DB  "Color "        ,0
msgMono     DB  "Mono  "        ,0

msgYes5     DB  "Yes  ",0
msgNot5     DB  "No   ",0
msgYes4     DB  "Yes " ,0
msgNot4     DB  "No  " ,0

msgMemPtr   DW  msgMemText, msgMemCGA , msgMemHerc, msgMem4pln, msgMemPack
            DW  msgMem4256, msgMemDirC, msgMemYUV

msgMemText  DB  "Txt mode ",0
msgMemCGA   DB  "CGA grph ",0
msgMemHerc  DB  "Herc grp ",0
msgMem4pln  DB  "4-planar ",0
msgMemPack  DB  "Pack pix ",0
msgMem4256  DB  "nch4,256 ",0
msgMemDirC  DB  "Dir Colr ",0
msgMemYUV   DB  "YUV      ",0
msgMemUnkn  DB  "         ",0

msgPause    DB  "Press any key to continue...",CR,0
msgPauseDel DB  "                            ",CR,0

;ͻ
;   
;ͼ

;-----------------------------------;
info      DB  512 dup (0)           ;  ଠ樨
mode      DB  512 dup (0)           ; ०
;-----------------------------------;
strVesa   DB  "VESA"  ,0            ; 䨪樮 ப
;-----------------------------------;
strSize   DB  "00000",0             ;  
strVers   DB  "00.00",0             ; 
;-----------------------------------;
strMode   DB  "0000 "  ,0           ; ०
strReso   DB  "0000 "  ,0           ; 襭
strFont   DB  "00x00 " ,0           ;  ᨬ
strMaps   DB  "0000  " ,0           ; ᫮ ᪮⥩
strPage   DB  "0000 "  ,0           ; ᫮ ࠭
                                    ;
strColors DB  "0000000000 ",0       ; ᫮ 梥⮢
strTruClr DB  "True-00bit ",0       ; 
;-----------------------------------;
scrBottom DB  0                     ; ᫮ ப  ࠭
scrRow    DB  0                     ; ᫮ 뢥 ப
;-----------------------------------;

.code
.startup
;ͻ
;  楤                                                    
;ͼ
vesaInit proc near

  @out  msgTitle              ;뢥 ᪨ ࠢ.
  mov   scrRow,4              ;( ? ப  ᯫ).

  lea   di,info               ; ଠ  SVGA.
  @int  VESA_INFO,10h

  lea   si,strVesa            ;஢ 稥 䨪樮
  mov   cx,4                  ;ப. ᫨ ᫥ 
  rep   cmpsb                 ;뤠 ᮮ饭   ࠡ
  @if   ZF == 0               ;ணࠬ.
        @out  msgNotVesa
        @quit 1
  @endif

  call  _scrFrame             ;   ᫮ ப
  mov   scrBottom,dh          ; ࠭.

  @out  msgVersion            ;뢥 .
  mov   ax,info.vers
  xor   bx,bx
  xchg  bl,ah

  @dcf  ax,strVers[3],2
  @dcv  bx,strVers[0],2

  @out  si
  call  Eject

  @out  msgFactory            ;뢥 ந⥫.
  push  ds
  lds   si,info.copyright
  @out  si
  call  Eject
  pop   ds

  @if   info.ramsize #= 0     ;뢥 ࠧ .
        @out msgRamSize
        mov  ax,info.ramsize
        mov  bx,64
        mul  bx
        lea  si,strSize
        mov  cx,5
        call _intDCV
        call _dosDisplay
        call Eject
  @endif

  @out  msgDACWidth           ;뢥 ਭ ॣ DAC

  @if   info.capabilit[3] && <mask switchDAC>
        @out msgDACSwtch
  @else
        @out msgDAC6bits
  @endif
  call  Eject

  call  Eject
  @out  msgVesaMode
  call  Eject
  call  Eject
  @out  msgHeapMode
  call  Eject
  @out  msgHeapLine
  call  Eject

  les   di,info.modetable     ;뢥 ⠭ VESA ०.
  @dowhile es:@word(di) #= NIL
    mov   cx,es:[di]
    call  vesaMode
    inc   di
    inc   di
  @enddo
; call  Eject
;
; @out  msgBiosMode
; call  Eject
; call  Eject
; @out  msgHeapMode
; call  Eject
; @out  msgHeapLine
; call  Eject
;
; xor   ax,ax                 ;᪠ ७ BIOS ०.
; @for  255
;   mov  cx,ax
;   call vesaMode
;   inc  ax
; @next

  @quit 0
endp

;ͻ
;  ଠ  ०                                    
;ͼ
vesaMode proc near Uses ax bx cx dx di si ds es

  push  cs
  pop   es
  lea   di,mode
  @int  VESA_MODE_INFO,10h      ; ଠ  ०

  @if   ah #= 0                 ;᫨ ०  ন,
        ret                     ; ࠢ.
  @endif

  @hcf  cx,strMode,4            ;뢥  ०
  @out  si

  @if mode.attribut && 10h      ;뢥 ⨯ ०:
      lea si,msgGraphic         ;᪨
  @else
      lea si,msgText            ;⥪⮢
  @endif
  call  _dosDisplay

  @if mode.attribut && 08h      ;뢥 梥⭮ ०:
      lea si,msgColor           ;梥⭮
  @else
      lea si,msgMono            ;୮-
  @endif
  call  _dosDisplay

  @if mode.attribut && 04h      ;뢥 ਧ প BIOS:
      lea si,msgYes5            ;
  @else
      lea si,msgNot5            ;
  @endif
  call  _dosDisplay

  @if mode.attribut && 01h      ;뢥 ਧ প 㤮:
      lea si,msgYes4            ;
  @else
      lea si,msgNot4            ;
  @endif
  call  _dosDisplay

  @if mode.attribut #& 02h      ;᫨ ⥫쭠 ଠ
      call  Eject               ;,   ⮬  
      ret                       ;砥.
  @endif

  @dcv  mode.cols,strReso,4     ;뢥 ࠧ襭.
  @out  strReso
  @dcv  mode.rows,strReso,4
  @out  strReso

  @if mode.colorbits -= 16
 
      mov   ax,1                    ;᫨ ⢮ 梥⮢.
      xor   dx,dx
      xor   cx,cx
      mov   cl,mode.colorbits
      @cycle cx
        shl ax,1
        rcl dx,1
      @endcycle

      mov   cx,10                   ;뢥 ᫮ 梥⮢.
      lea   si,strColors
      call  _intDCV
      @out  strColors
  @else
      xor   ax,ax
      xor   dx,dx
      mov   al,mode.colorbits
      mov   cx,2                    ;뢥 ᫮ 梥⮢.
      lea   si,strTruClr+5
      call  _intDCV
      @out  strTruClr

  @endif

  xor   ax,ax                   ;뢥 ࠧ ᨬ.
  mov   al,mode.charwidth
  @dcf  ax,strFont[0],2
  mov   al,mode.charheight
  @dcf  ax,strFont[3],2
  @out  strFont

  xor   bh,bh
  mov   bl,mode.memorymod
  @if   bx ++ VMM_VALID
        lea si,msgMemUnkn
  @else
        shl bx,1
        mov si,msgMemPtr[bx]
  @endif
  @out  si

  xor   ax,ax                   ;뢥 ᫮ ᪮⥩.
  mov   al,mode.maps
  @dcv  ax,strMaps,4
  @out  strMaps

  xor   ax,ax                   ;뢥 ᫮ ࠭.
  mov   al,mode.pages
  @dcv  ax,strPage,4
  @out  strPage

  mov   ax,0
  call  vesaWindow              ;뢥 ਡ  A

  mov   al," "
  call  _dosChar
  call  _dosChar

  mov   ax,1
  call  vesaWindow              ;뢥 ਡ  B

  call  Eject
  ret
endp

;ͻ
; 뢥 ਡ                                                 
;ͼ
vesaWindow proc near

  mov   bx,ax
  mov   dl,mode.winAattr[bx]      ;㧨 ਡ 
  @if   dl && <mask winsupport>   ;뢥 ਧ প
        mov al,"+"                ; .
  @else
        mov al,"-"
  @endif
  call  _dosChar

  @if   dl && <mask winread>      ;뢥 ਧ প
        mov al,"R"                ;⥭   .
  @else
        mov al," "
  @endif
  call  _dosChar

  @if   dl && <mask winwrite>     ;뢥 ਧ প
        mov al,"W"                ;   .
  @else
        mov al," "
  @endif
  call  _dosChar
  ret
endp

;ͻ
; ॢ ப                                                       
;ͼ
Eject proc near uses ax bx cx dx di si ds es

  call _dosEject  ;ॢ ப 
  inc  scrRow     ;㢥 稪 ப.

  mov  ah,scrRow
  @if  ah == scrBottom
       call _dosReDirect?
       @if  al == FALSE
            @out msgPause
            @int 0,16h
            @out msgPauseDel
            mov  scrRow,0
       @endif
  @endif

  ret
endp

end @Startup
